/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package com.acme.reactivex.pkg;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link com.acme.pkg.MyInterface original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(com.acme.pkg.MyInterface.class)
public class MyInterface {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    MyInterface that = (MyInterface) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<MyInterface> __TYPE_ARG = new TypeArg<>(    obj -> new MyInterface((com.acme.pkg.MyInterface) obj),
    MyInterface::getDelegate
  );

  private final com.acme.pkg.MyInterface delegate;
  
  public MyInterface(com.acme.pkg.MyInterface delegate) {
    this.delegate = delegate;
  }

  public MyInterface(Object delegate) {
    this.delegate = (com.acme.pkg.MyInterface)delegate;
  }

  public com.acme.pkg.MyInterface getDelegate() {
    return delegate;
  }

  public static com.acme.reactivex.pkg.MyInterface create() { 
    com.acme.reactivex.pkg.MyInterface ret = com.acme.reactivex.pkg.MyInterface.newInstance((com.acme.pkg.MyInterface)com.acme.pkg.MyInterface.create());
    return ret;
  }

  public com.acme.reactivex.pkg.sub.SubInterface sub() { 
    com.acme.reactivex.pkg.sub.SubInterface ret = com.acme.reactivex.pkg.sub.SubInterface.newInstance((com.acme.pkg.sub.SubInterface)delegate.sub());
    return ret;
  }

  public io.vertx.reactivex.codegen.testmodel.TestInterface method() { 
    io.vertx.reactivex.codegen.testmodel.TestInterface ret = io.vertx.reactivex.codegen.testmodel.TestInterface.newInstance((io.vertx.codegen.testmodel.TestInterface)delegate.method());
    return ret;
  }

  public static MyInterface newInstance(com.acme.pkg.MyInterface arg) {
    return arg != null ? new MyInterface(arg) : null;
  }

}
