/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.codegen.testmodel;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.CollectionTCK original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.CollectionTCK.class)
public class CollectionTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    CollectionTCK that = (CollectionTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<CollectionTCK> __TYPE_ARG = new TypeArg<>(    obj -> new CollectionTCK((io.vertx.codegen.testmodel.CollectionTCK) obj),
    CollectionTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.CollectionTCK delegate;
  
  public CollectionTCK(io.vertx.codegen.testmodel.CollectionTCK delegate) {
    this.delegate = delegate;
  }

  public CollectionTCK(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.CollectionTCK)delegate;
  }

  public io.vertx.codegen.testmodel.CollectionTCK getDelegate() {
    return delegate;
  }

  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_0 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());
  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_1 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());
  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_2 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());

  public void methodWithListParams(List<String> listString, List<Byte> listByte, List<Short> listShort, List<Integer> listInt, List<Long> listLong, List<JsonObject> listJsonObject, List<JsonArray> listJsonArray, List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> listVertxGen, List<io.vertx.codegen.testmodel.TestDataObject> listDataObject, List<io.vertx.codegen.testmodel.TestEnum> listEnum, List<java.lang.Object> listObject) { 
    delegate.methodWithListParams(listString, listByte, listShort, listInt, listLong, listJsonObject, listJsonArray, listVertxGen.stream().map(elt -> elt.getDelegate()).collect(Collectors.toList()), listDataObject, listEnum, listObject);
  }

  public void methodWithSetParams(Set<String> setString, Set<Byte> setByte, Set<Short> setShort, Set<Integer> setInt, Set<Long> setLong, Set<JsonObject> setJsonObject, Set<JsonArray> setJsonArray, Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> setVertxGen, Set<io.vertx.codegen.testmodel.TestDataObject> setDataObject, Set<io.vertx.codegen.testmodel.TestEnum> setEnum, Set<java.lang.Object> setObject) { 
    delegate.methodWithSetParams(setString, setByte, setShort, setInt, setLong, setJsonObject, setJsonArray, setVertxGen.stream().map(elt -> elt.getDelegate()).collect(Collectors.toSet()), setDataObject, setEnum, setObject);
  }

  public void methodWithMapParams(java.util.Map<String, String> mapString, java.util.Map<String, Byte> mapByte, java.util.Map<String, Short> mapShort, java.util.Map<String, Integer> mapInt, java.util.Map<String, Long> mapLong, java.util.Map<String, JsonObject> mapJsonObject, java.util.Map<String, JsonArray> mapJsonArray, java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> mapVertxGen, java.util.Map<String, io.vertx.codegen.testmodel.TestDataObject> mapDataObject, java.util.Map<String, io.vertx.codegen.testmodel.TestEnum> mapEnum, java.util.Map<String, java.lang.Object> mapObject) { 
    delegate.methodWithMapParams(mapString, mapByte, mapShort, mapInt, mapLong, mapJsonObject, mapJsonArray, mapVertxGen.entrySet().stream().collect(Collectors.toMap(e -> e.getKey(), e -> e.getValue().getDelegate())), mapDataObject, mapEnum, mapObject);
  }

  public void methodWithHandlerListAndSet(Handler<List<String>> listStringHandler, Handler<List<Integer>> listIntHandler, Handler<Set<String>> setStringHandler, Handler<Set<Integer>> setIntHandler) { 
    delegate.methodWithHandlerListAndSet(listStringHandler, listIntHandler, setStringHandler, setIntHandler);
  }

  public void methodWithHandlerAsyncResultListString(Handler<AsyncResult<List<String>>> handler) { 
    delegate.methodWithHandlerAsyncResultListString(handler);
  }

  public void methodWithHandlerAsyncResultListString() {
    methodWithHandlerAsyncResultListString(ar -> { });
  }

  public io.reactivex.Single<List<String>> rxMethodWithHandlerAsyncResultListString() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListString($handler);
    });
  }

  public void methodWithHandlerAsyncResultListInteger(Handler<AsyncResult<List<Integer>>> handler) { 
    delegate.methodWithHandlerAsyncResultListInteger(handler);
  }

  public void methodWithHandlerAsyncResultListInteger() {
    methodWithHandlerAsyncResultListInteger(ar -> { });
  }

  public io.reactivex.Single<List<Integer>> rxMethodWithHandlerAsyncResultListInteger() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListInteger($handler);
    });
  }

  public void methodWithHandlerListVertxGen(Handler<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> listHandler) { 
    delegate.methodWithHandlerListVertxGen(new Handler<List<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(List<io.vertx.codegen.testmodel.RefedInterface1> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList()));
      }
    });
  }

  public void methodWithHandlerListAbstractVertxGen(Handler<List<io.vertx.reactivex.codegen.testmodel.RefedInterface2>> listHandler) { 
    delegate.methodWithHandlerListAbstractVertxGen(new Handler<List<io.vertx.codegen.testmodel.RefedInterface2>>() {
      public void handle(List<io.vertx.codegen.testmodel.RefedInterface2> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface2.newInstance((io.vertx.codegen.testmodel.RefedInterface2)elt)).collect(Collectors.toList()));
      }
    });
  }

  public void methodWithHandlerListJsonObject(Handler<List<JsonObject>> listHandler) { 
    delegate.methodWithHandlerListJsonObject(listHandler);
  }

  public void methodWithHandlerListComplexJsonObject(Handler<List<JsonObject>> listHandler) { 
    delegate.methodWithHandlerListComplexJsonObject(listHandler);
  }

  public void methodWithHandlerListJsonArray(Handler<List<JsonArray>> listHandler) { 
    delegate.methodWithHandlerListJsonArray(listHandler);
  }

  public void methodWithHandlerListComplexJsonArray(Handler<List<JsonArray>> listHandler) { 
    delegate.methodWithHandlerListComplexJsonArray(listHandler);
  }

  public void methodWithHandlerListDataObject(Handler<List<io.vertx.codegen.testmodel.TestDataObject>> listHandler) { 
    delegate.methodWithHandlerListDataObject(listHandler);
  }

  public void methodWithHandlerListEnum(Handler<List<io.vertx.codegen.testmodel.TestEnum>> listHandler) { 
    delegate.methodWithHandlerListEnum(listHandler);
  }

  public void methodWithHandlerAsyncResultSetString(Handler<AsyncResult<Set<String>>> handler) { 
    delegate.methodWithHandlerAsyncResultSetString(handler);
  }

  public void methodWithHandlerAsyncResultSetString() {
    methodWithHandlerAsyncResultSetString(ar -> { });
  }

  public io.reactivex.Single<Set<String>> rxMethodWithHandlerAsyncResultSetString() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetString($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetInteger(Handler<AsyncResult<Set<Integer>>> handler) { 
    delegate.methodWithHandlerAsyncResultSetInteger(handler);
  }

  public void methodWithHandlerAsyncResultSetInteger() {
    methodWithHandlerAsyncResultSetInteger(ar -> { });
  }

  public io.reactivex.Single<Set<Integer>> rxMethodWithHandlerAsyncResultSetInteger() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetInteger($handler);
    });
  }

  public void methodWithHandlerSetVertxGen(Handler<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> listHandler) { 
    delegate.methodWithHandlerSetVertxGen(new Handler<Set<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(Set<io.vertx.codegen.testmodel.RefedInterface1> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet()));
      }
    });
  }

  public void methodWithHandlerSetAbstractVertxGen(Handler<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface2>> listHandler) { 
    delegate.methodWithHandlerSetAbstractVertxGen(new Handler<Set<io.vertx.codegen.testmodel.RefedInterface2>>() {
      public void handle(Set<io.vertx.codegen.testmodel.RefedInterface2> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface2.newInstance((io.vertx.codegen.testmodel.RefedInterface2)elt)).collect(Collectors.toSet()));
      }
    });
  }

  public void methodWithHandlerSetJsonObject(Handler<Set<JsonObject>> listHandler) { 
    delegate.methodWithHandlerSetJsonObject(listHandler);
  }

  public void methodWithHandlerSetComplexJsonObject(Handler<Set<JsonObject>> listHandler) { 
    delegate.methodWithHandlerSetComplexJsonObject(listHandler);
  }

  public void methodWithHandlerSetJsonArray(Handler<Set<JsonArray>> listHandler) { 
    delegate.methodWithHandlerSetJsonArray(listHandler);
  }

  public void methodWithHandlerSetComplexJsonArray(Handler<Set<JsonArray>> setHandler) { 
    delegate.methodWithHandlerSetComplexJsonArray(setHandler);
  }

  public void methodWithHandlerSetDataObject(Handler<Set<io.vertx.codegen.testmodel.TestDataObject>> setHandler) { 
    delegate.methodWithHandlerSetDataObject(setHandler);
  }

  public void methodWithHandlerSetEnum(Handler<Set<io.vertx.codegen.testmodel.TestEnum>> setHandler) { 
    delegate.methodWithHandlerSetEnum(setHandler);
  }

  public void methodWithHandlerAsyncResultListVertxGen(Handler<AsyncResult<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListVertxGen(new Handler<AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithHandlerAsyncResultListVertxGen() {
    methodWithHandlerAsyncResultListVertxGen(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultListVertxGen() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListVertxGen($handler);
    });
  }

  public void methodWithHandlerAsyncResultListAbstractVertxGen(Handler<AsyncResult<List<io.vertx.reactivex.codegen.testmodel.RefedInterface2>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListAbstractVertxGen(new Handler<AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface2>>>() {
      public void handle(AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface2>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface2.newInstance((io.vertx.codegen.testmodel.RefedInterface2)elt)).collect(Collectors.toList())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithHandlerAsyncResultListAbstractVertxGen() {
    methodWithHandlerAsyncResultListAbstractVertxGen(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.reactivex.codegen.testmodel.RefedInterface2>> rxMethodWithHandlerAsyncResultListAbstractVertxGen() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListAbstractVertxGen($handler);
    });
  }

  public void methodWithHandlerAsyncResultListJsonObject(Handler<AsyncResult<List<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListJsonObject(listHandler);
  }

  public void methodWithHandlerAsyncResultListJsonObject() {
    methodWithHandlerAsyncResultListJsonObject(ar -> { });
  }

  public io.reactivex.Single<List<JsonObject>> rxMethodWithHandlerAsyncResultListJsonObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListJsonObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultListComplexJsonObject(Handler<AsyncResult<List<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListComplexJsonObject(listHandler);
  }

  public void methodWithHandlerAsyncResultListComplexJsonObject() {
    methodWithHandlerAsyncResultListComplexJsonObject(ar -> { });
  }

  public io.reactivex.Single<List<JsonObject>> rxMethodWithHandlerAsyncResultListComplexJsonObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListComplexJsonObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultListJsonArray(Handler<AsyncResult<List<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListJsonArray(listHandler);
  }

  public void methodWithHandlerAsyncResultListJsonArray() {
    methodWithHandlerAsyncResultListJsonArray(ar -> { });
  }

  public io.reactivex.Single<List<JsonArray>> rxMethodWithHandlerAsyncResultListJsonArray() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListJsonArray($handler);
    });
  }

  public void methodWithHandlerAsyncResultListComplexJsonArray(Handler<AsyncResult<List<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListComplexJsonArray(listHandler);
  }

  public void methodWithHandlerAsyncResultListComplexJsonArray() {
    methodWithHandlerAsyncResultListComplexJsonArray(ar -> { });
  }

  public io.reactivex.Single<List<JsonArray>> rxMethodWithHandlerAsyncResultListComplexJsonArray() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListComplexJsonArray($handler);
    });
  }

  public void methodWithHandlerAsyncResultListDataObject(Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestDataObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListDataObject(listHandler);
  }

  public void methodWithHandlerAsyncResultListDataObject() {
    methodWithHandlerAsyncResultListDataObject(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithHandlerAsyncResultListDataObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListDataObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultListEnum(Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestEnum>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListEnum(listHandler);
  }

  public void methodWithHandlerAsyncResultListEnum() {
    methodWithHandlerAsyncResultListEnum(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithHandlerAsyncResultListEnum() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultListEnum($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetVertxGen(Handler<AsyncResult<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetVertxGen(new Handler<AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithHandlerAsyncResultSetVertxGen() {
    methodWithHandlerAsyncResultSetVertxGen(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultSetVertxGen() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetVertxGen($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetAbstractVertxGen(Handler<AsyncResult<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface2>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetAbstractVertxGen(new Handler<AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface2>>>() {
      public void handle(AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface2>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface2.newInstance((io.vertx.codegen.testmodel.RefedInterface2)elt)).collect(Collectors.toSet())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithHandlerAsyncResultSetAbstractVertxGen() {
    methodWithHandlerAsyncResultSetAbstractVertxGen(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface2>> rxMethodWithHandlerAsyncResultSetAbstractVertxGen() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetAbstractVertxGen($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetJsonObject(Handler<AsyncResult<Set<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetJsonObject(listHandler);
  }

  public void methodWithHandlerAsyncResultSetJsonObject() {
    methodWithHandlerAsyncResultSetJsonObject(ar -> { });
  }

  public io.reactivex.Single<Set<JsonObject>> rxMethodWithHandlerAsyncResultSetJsonObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetJsonObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetComplexJsonObject(Handler<AsyncResult<Set<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetComplexJsonObject(listHandler);
  }

  public void methodWithHandlerAsyncResultSetComplexJsonObject() {
    methodWithHandlerAsyncResultSetComplexJsonObject(ar -> { });
  }

  public io.reactivex.Single<Set<JsonObject>> rxMethodWithHandlerAsyncResultSetComplexJsonObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetComplexJsonObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetJsonArray(Handler<AsyncResult<Set<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetJsonArray(listHandler);
  }

  public void methodWithHandlerAsyncResultSetJsonArray() {
    methodWithHandlerAsyncResultSetJsonArray(ar -> { });
  }

  public io.reactivex.Single<Set<JsonArray>> rxMethodWithHandlerAsyncResultSetJsonArray() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetJsonArray($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetComplexJsonArray(Handler<AsyncResult<Set<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetComplexJsonArray(listHandler);
  }

  public void methodWithHandlerAsyncResultSetComplexJsonArray() {
    methodWithHandlerAsyncResultSetComplexJsonArray(ar -> { });
  }

  public io.reactivex.Single<Set<JsonArray>> rxMethodWithHandlerAsyncResultSetComplexJsonArray() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetComplexJsonArray($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetDataObject(Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestDataObject>>> setHandler) { 
    delegate.methodWithHandlerAsyncResultSetDataObject(setHandler);
  }

  public void methodWithHandlerAsyncResultSetDataObject() {
    methodWithHandlerAsyncResultSetDataObject(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithHandlerAsyncResultSetDataObject() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetDataObject($handler);
    });
  }

  public void methodWithHandlerAsyncResultSetEnum(Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestEnum>>> setHandler) { 
    delegate.methodWithHandlerAsyncResultSetEnum(setHandler);
  }

  public void methodWithHandlerAsyncResultSetEnum() {
    methodWithHandlerAsyncResultSetEnum(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithHandlerAsyncResultSetEnum() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithHandlerAsyncResultSetEnum($handler);
    });
  }

  public java.util.Map<String, String> methodWithMapStringReturn(Handler<String> handler) { 
    java.util.Map<String, String> ret = delegate.methodWithMapStringReturn(handler);
    return ret;
  }

  public java.util.Map<String, Long> methodWithMapLongReturn(Handler<String> handler) { 
    java.util.Map<String, Long> ret = delegate.methodWithMapLongReturn(handler);
    return ret;
  }

  public java.util.Map<String, Integer> methodWithMapIntegerReturn(Handler<String> handler) { 
    java.util.Map<String, Integer> ret = delegate.methodWithMapIntegerReturn(handler);
    return ret;
  }

  public java.util.Map<String, Short> methodWithMapShortReturn(Handler<String> handler) { 
    java.util.Map<String, Short> ret = delegate.methodWithMapShortReturn(handler);
    return ret;
  }

  public java.util.Map<String, Byte> methodWithMapByteReturn(Handler<String> handler) { 
    java.util.Map<String, Byte> ret = delegate.methodWithMapByteReturn(handler);
    return ret;
  }

  public java.util.Map<String, Character> methodWithMapCharacterReturn(Handler<String> handler) { 
    java.util.Map<String, Character> ret = delegate.methodWithMapCharacterReturn(handler);
    return ret;
  }

  public java.util.Map<String, Boolean> methodWithMapBooleanReturn(Handler<String> handler) { 
    java.util.Map<String, Boolean> ret = delegate.methodWithMapBooleanReturn(handler);
    return ret;
  }

  public java.util.Map<String, Float> methodWithMapFloatReturn(Handler<String> handler) { 
    java.util.Map<String, Float> ret = delegate.methodWithMapFloatReturn(handler);
    return ret;
  }

  public java.util.Map<String, Double> methodWithMapDoubleReturn(Handler<String> handler) { 
    java.util.Map<String, Double> ret = delegate.methodWithMapDoubleReturn(handler);
    return ret;
  }

  public java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithMapVertxGenReturn(Handler<String> handler) { 
    java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithMapVertxGenReturn(handler).entrySet().stream().collect(Collectors.toMap(_e -> _e.getKey(), _e -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)_e.getValue())));
    return ret;
  }

  public java.util.Map<String, io.vertx.codegen.testmodel.TestDataObject> methodWithMapDataObjectReturn(Handler<String> handler) { 
    java.util.Map<String, io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithMapDataObjectReturn(handler);
    return ret;
  }

  public java.util.Map<String, io.vertx.codegen.testmodel.TestEnum> methodWithMapEnumReturn(Handler<String> handler) { 
    java.util.Map<String, io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithMapEnumReturn(handler);
    return ret;
  }

  public java.util.Map<String, JsonObject> methodWithMapJsonObjectReturn(Handler<String> handler) { 
    java.util.Map<String, JsonObject> ret = delegate.methodWithMapJsonObjectReturn(handler);
    return ret;
  }

  public java.util.Map<String, JsonObject> methodWithMapComplexJsonObjectReturn(Handler<String> handler) { 
    java.util.Map<String, JsonObject> ret = delegate.methodWithMapComplexJsonObjectReturn(handler);
    return ret;
  }

  public java.util.Map<String, JsonArray> methodWithMapJsonArrayReturn(Handler<String> handler) { 
    java.util.Map<String, JsonArray> ret = delegate.methodWithMapJsonArrayReturn(handler);
    return ret;
  }

  public java.util.Map<String, JsonArray> methodWithMapComplexJsonArrayReturn(Handler<String> handler) { 
    java.util.Map<String, JsonArray> ret = delegate.methodWithMapComplexJsonArrayReturn(handler);
    return ret;
  }

  public java.util.Map<String, java.lang.Object> methodWithMapObjectReturn(Handler<String> handler) { 
    java.util.Map<String, java.lang.Object> ret = delegate.methodWithMapObjectReturn(handler);
    return ret;
  }

  public List<String> methodWithListStringReturn() { 
    List<String> ret = delegate.methodWithListStringReturn();
    return ret;
  }

  public List<Long> methodWithListLongReturn() { 
    List<Long> ret = delegate.methodWithListLongReturn();
    return ret;
  }

  public List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithListVertxGenReturn() { 
    List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithListVertxGenReturn().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList());
    return ret;
  }

  public List<JsonObject> methodWithListJsonObjectReturn() { 
    List<JsonObject> ret = delegate.methodWithListJsonObjectReturn();
    return ret;
  }

  public List<JsonObject> methodWithListComplexJsonObjectReturn() { 
    List<JsonObject> ret = delegate.methodWithListComplexJsonObjectReturn();
    return ret;
  }

  public List<JsonArray> methodWithListJsonArrayReturn() { 
    List<JsonArray> ret = delegate.methodWithListJsonArrayReturn();
    return ret;
  }

  public List<JsonArray> methodWithListComplexJsonArrayReturn() { 
    List<JsonArray> ret = delegate.methodWithListComplexJsonArrayReturn();
    return ret;
  }

  public List<io.vertx.codegen.testmodel.TestDataObject> methodWithListDataObjectReturn() { 
    List<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithListDataObjectReturn();
    return ret;
  }

  public List<io.vertx.codegen.testmodel.TestEnum> methodWithListEnumReturn() { 
    List<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithListEnumReturn();
    return ret;
  }

  public List<java.lang.Object> methodWithListObjectReturn() { 
    List<java.lang.Object> ret = delegate.methodWithListObjectReturn();
    return ret;
  }

  public Set<String> methodWithSetStringReturn() { 
    Set<String> ret = delegate.methodWithSetStringReturn();
    return ret;
  }

  public Set<Long> methodWithSetLongReturn() { 
    Set<Long> ret = delegate.methodWithSetLongReturn();
    return ret;
  }

  public Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithSetVertxGenReturn() { 
    Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithSetVertxGenReturn().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet());
    return ret;
  }

  public Set<JsonObject> methodWithSetJsonObjectReturn() { 
    Set<JsonObject> ret = delegate.methodWithSetJsonObjectReturn();
    return ret;
  }

  public Set<JsonObject> methodWithSetComplexJsonObjectReturn() { 
    Set<JsonObject> ret = delegate.methodWithSetComplexJsonObjectReturn();
    return ret;
  }

  public Set<JsonArray> methodWithSetJsonArrayReturn() { 
    Set<JsonArray> ret = delegate.methodWithSetJsonArrayReturn();
    return ret;
  }

  public Set<JsonArray> methodWithSetComplexJsonArrayReturn() { 
    Set<JsonArray> ret = delegate.methodWithSetComplexJsonArrayReturn();
    return ret;
  }

  public Set<io.vertx.codegen.testmodel.TestDataObject> methodWithSetDataObjectReturn() { 
    Set<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithSetDataObjectReturn();
    return ret;
  }

  public Set<io.vertx.codegen.testmodel.TestEnum> methodWithSetEnumReturn() { 
    Set<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithSetEnumReturn();
    return ret;
  }

  public Set<java.lang.Object> methodWithSetObjectReturn() { 
    Set<java.lang.Object> ret = delegate.methodWithSetObjectReturn();
    return ret;
  }

  public static CollectionTCK newInstance(io.vertx.codegen.testmodel.CollectionTCK arg) {
    return arg != null ? new CollectionTCK(arg) : null;
  }

}
