/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.codegen.testmodel;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * The TCK for @Nullable.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.NullableTCK original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.NullableTCK.class)
public class NullableTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    NullableTCK that = (NullableTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<NullableTCK> __TYPE_ARG = new TypeArg<>(    obj -> new NullableTCK((io.vertx.codegen.testmodel.NullableTCK) obj),
    NullableTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.NullableTCK delegate;
  
  public NullableTCK(io.vertx.codegen.testmodel.NullableTCK delegate) {
    this.delegate = delegate;
  }

  public NullableTCK(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.NullableTCK)delegate;
  }

  public io.vertx.codegen.testmodel.NullableTCK getDelegate() {
    return delegate;
  }

  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_0 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());
  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_1 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());
  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_2 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());
  private static final TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1> TYPE_ARG_3 = new TypeArg<io.vertx.reactivex.codegen.testmodel.RefedInterface1>(o1 -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)o1), o1 -> o1.getDelegate());

  public boolean methodWithNonNullableByteParam(Byte param) { 
    boolean ret = delegate.methodWithNonNullableByteParam(param);
    return ret;
  }

  public void methodWithNullableByteParam(boolean expectNull, Byte param) { 
    delegate.methodWithNullableByteParam(expectNull, param);
  }

  public void methodWithNullableByteHandler(boolean notNull, Handler<Byte> handler) { 
    delegate.methodWithNullableByteHandler(notNull, handler);
  }

  public void methodWithNullableByteHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Byte>> handler) { 
    delegate.methodWithNullableByteHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableByteHandlerAsyncResult(boolean notNull) {
    methodWithNullableByteHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Byte> rxMethodWithNullableByteHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableByteHandlerAsyncResult(notNull, $handler);
    });
  }

  public Byte methodWithNullableByteReturn(boolean notNull) { 
    Byte ret = delegate.methodWithNullableByteReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableShortParam(Short param) { 
    boolean ret = delegate.methodWithNonNullableShortParam(param);
    return ret;
  }

  public void methodWithNullableShortParam(boolean expectNull, Short param) { 
    delegate.methodWithNullableShortParam(expectNull, param);
  }

  public void methodWithNullableShortHandler(boolean notNull, Handler<Short> handler) { 
    delegate.methodWithNullableShortHandler(notNull, handler);
  }

  public void methodWithNullableShortHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Short>> handler) { 
    delegate.methodWithNullableShortHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableShortHandlerAsyncResult(boolean notNull) {
    methodWithNullableShortHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Short> rxMethodWithNullableShortHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableShortHandlerAsyncResult(notNull, $handler);
    });
  }

  public Short methodWithNullableShortReturn(boolean notNull) { 
    Short ret = delegate.methodWithNullableShortReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableIntegerParam(Integer param) { 
    boolean ret = delegate.methodWithNonNullableIntegerParam(param);
    return ret;
  }

  public void methodWithNullableIntegerParam(boolean expectNull, Integer param) { 
    delegate.methodWithNullableIntegerParam(expectNull, param);
  }

  public void methodWithNullableIntegerHandler(boolean notNull, Handler<Integer> handler) { 
    delegate.methodWithNullableIntegerHandler(notNull, handler);
  }

  public void methodWithNullableIntegerHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Integer>> handler) { 
    delegate.methodWithNullableIntegerHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableIntegerHandlerAsyncResult(boolean notNull) {
    methodWithNullableIntegerHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Integer> rxMethodWithNullableIntegerHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableIntegerHandlerAsyncResult(notNull, $handler);
    });
  }

  public Integer methodWithNullableIntegerReturn(boolean notNull) { 
    Integer ret = delegate.methodWithNullableIntegerReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableLongParam(Long param) { 
    boolean ret = delegate.methodWithNonNullableLongParam(param);
    return ret;
  }

  public void methodWithNullableLongParam(boolean expectNull, Long param) { 
    delegate.methodWithNullableLongParam(expectNull, param);
  }

  public void methodWithNullableLongHandler(boolean notNull, Handler<Long> handler) { 
    delegate.methodWithNullableLongHandler(notNull, handler);
  }

  public void methodWithNullableLongHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Long>> handler) { 
    delegate.methodWithNullableLongHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableLongHandlerAsyncResult(boolean notNull) {
    methodWithNullableLongHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Long> rxMethodWithNullableLongHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableLongHandlerAsyncResult(notNull, $handler);
    });
  }

  public Long methodWithNullableLongReturn(boolean notNull) { 
    Long ret = delegate.methodWithNullableLongReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableFloatParam(Float param) { 
    boolean ret = delegate.methodWithNonNullableFloatParam(param);
    return ret;
  }

  public void methodWithNullableFloatParam(boolean expectNull, Float param) { 
    delegate.methodWithNullableFloatParam(expectNull, param);
  }

  public void methodWithNullableFloatHandler(boolean notNull, Handler<Float> handler) { 
    delegate.methodWithNullableFloatHandler(notNull, handler);
  }

  public void methodWithNullableFloatHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Float>> handler) { 
    delegate.methodWithNullableFloatHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableFloatHandlerAsyncResult(boolean notNull) {
    methodWithNullableFloatHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Float> rxMethodWithNullableFloatHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableFloatHandlerAsyncResult(notNull, $handler);
    });
  }

  public Float methodWithNullableFloatReturn(boolean notNull) { 
    Float ret = delegate.methodWithNullableFloatReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableDoubleParam(Double param) { 
    boolean ret = delegate.methodWithNonNullableDoubleParam(param);
    return ret;
  }

  public void methodWithNullableDoubleParam(boolean expectNull, Double param) { 
    delegate.methodWithNullableDoubleParam(expectNull, param);
  }

  public void methodWithNullableDoubleHandler(boolean notNull, Handler<Double> handler) { 
    delegate.methodWithNullableDoubleHandler(notNull, handler);
  }

  public void methodWithNullableDoubleHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Double>> handler) { 
    delegate.methodWithNullableDoubleHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableDoubleHandlerAsyncResult(boolean notNull) {
    methodWithNullableDoubleHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Double> rxMethodWithNullableDoubleHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableDoubleHandlerAsyncResult(notNull, $handler);
    });
  }

  public Double methodWithNullableDoubleReturn(boolean notNull) { 
    Double ret = delegate.methodWithNullableDoubleReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableBooleanParam(Boolean param) { 
    boolean ret = delegate.methodWithNonNullableBooleanParam(param);
    return ret;
  }

  public void methodWithNullableBooleanParam(boolean expectNull, Boolean param) { 
    delegate.methodWithNullableBooleanParam(expectNull, param);
  }

  public void methodWithNullableBooleanHandler(boolean notNull, Handler<Boolean> handler) { 
    delegate.methodWithNullableBooleanHandler(notNull, handler);
  }

  public void methodWithNullableBooleanHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Boolean>> handler) { 
    delegate.methodWithNullableBooleanHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableBooleanHandlerAsyncResult(boolean notNull) {
    methodWithNullableBooleanHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Boolean> rxMethodWithNullableBooleanHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableBooleanHandlerAsyncResult(notNull, $handler);
    });
  }

  public Boolean methodWithNullableBooleanReturn(boolean notNull) { 
    Boolean ret = delegate.methodWithNullableBooleanReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableStringParam(String param) { 
    boolean ret = delegate.methodWithNonNullableStringParam(param);
    return ret;
  }

  public void methodWithNullableStringParam(boolean expectNull, String param) { 
    delegate.methodWithNullableStringParam(expectNull, param);
  }

  public void methodWithNullableStringHandler(boolean notNull, Handler<String> handler) { 
    delegate.methodWithNullableStringHandler(notNull, handler);
  }

  public void methodWithNullableStringHandlerAsyncResult(boolean notNull, Handler<AsyncResult<String>> handler) { 
    delegate.methodWithNullableStringHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableStringHandlerAsyncResult(boolean notNull) {
    methodWithNullableStringHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<String> rxMethodWithNullableStringHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableStringHandlerAsyncResult(notNull, $handler);
    });
  }

  public String methodWithNullableStringReturn(boolean notNull) { 
    String ret = delegate.methodWithNullableStringReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableCharParam(Character param) { 
    boolean ret = delegate.methodWithNonNullableCharParam(param);
    return ret;
  }

  public void methodWithNullableCharParam(boolean expectNull, Character param) { 
    delegate.methodWithNullableCharParam(expectNull, param);
  }

  public void methodWithNullableCharHandler(boolean notNull, Handler<Character> handler) { 
    delegate.methodWithNullableCharHandler(notNull, handler);
  }

  public void methodWithNullableCharHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Character>> handler) { 
    delegate.methodWithNullableCharHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableCharHandlerAsyncResult(boolean notNull) {
    methodWithNullableCharHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Character> rxMethodWithNullableCharHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableCharHandlerAsyncResult(notNull, $handler);
    });
  }

  public Character methodWithNullableCharReturn(boolean notNull) { 
    Character ret = delegate.methodWithNullableCharReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableJsonObjectParam(JsonObject param) { 
    boolean ret = delegate.methodWithNonNullableJsonObjectParam(param);
    return ret;
  }

  public void methodWithNullableJsonObjectParam(boolean expectNull, JsonObject param) { 
    delegate.methodWithNullableJsonObjectParam(expectNull, param);
  }

  public void methodWithNullableJsonObjectHandler(boolean notNull, Handler<JsonObject> handler) { 
    delegate.methodWithNullableJsonObjectHandler(notNull, handler);
  }

  public void methodWithNullableJsonObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<JsonObject>> handler) { 
    delegate.methodWithNullableJsonObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableJsonObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableJsonObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<JsonObject> rxMethodWithNullableJsonObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableJsonObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public JsonObject methodWithNullableJsonObjectReturn(boolean notNull) { 
    JsonObject ret = delegate.methodWithNullableJsonObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableJsonArrayParam(JsonArray param) { 
    boolean ret = delegate.methodWithNonNullableJsonArrayParam(param);
    return ret;
  }

  public void methodWithNullableJsonArrayParam(boolean expectNull, JsonArray param) { 
    delegate.methodWithNullableJsonArrayParam(expectNull, param);
  }

  public void methodWithNullableJsonArrayHandler(boolean notNull, Handler<JsonArray> handler) { 
    delegate.methodWithNullableJsonArrayHandler(notNull, handler);
  }

  public void methodWithNullableJsonArrayHandlerAsyncResult(boolean notNull, Handler<AsyncResult<JsonArray>> handler) { 
    delegate.methodWithNullableJsonArrayHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableJsonArrayHandlerAsyncResult(boolean notNull) {
    methodWithNullableJsonArrayHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<JsonArray> rxMethodWithNullableJsonArrayHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableJsonArrayHandlerAsyncResult(notNull, $handler);
    });
  }

  public JsonArray methodWithNullableJsonArrayReturn(boolean notNull) { 
    JsonArray ret = delegate.methodWithNullableJsonArrayReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableApiParam(io.vertx.reactivex.codegen.testmodel.RefedInterface1 param) { 
    boolean ret = delegate.methodWithNonNullableApiParam(param.getDelegate());
    return ret;
  }

  public void methodWithNullableApiParam(boolean expectNull, io.vertx.reactivex.codegen.testmodel.RefedInterface1 param) { 
    delegate.methodWithNullableApiParam(expectNull, param.getDelegate());
  }

  public void methodWithNullableApiHandler(boolean notNull, Handler<io.vertx.reactivex.codegen.testmodel.RefedInterface1> handler) { 
    delegate.methodWithNullableApiHandler(notNull, new Handler<io.vertx.codegen.testmodel.RefedInterface1>() {
      public void handle(io.vertx.codegen.testmodel.RefedInterface1 event) {
        handler.handle(io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)event));
      }
    });
  }

  public void methodWithNullableApiHandlerAsyncResult(boolean notNull, Handler<AsyncResult<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithNullableApiHandlerAsyncResult(notNull, new Handler<AsyncResult<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.RefedInterface1> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)ar.result())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithNullableApiHandlerAsyncResult(boolean notNull) {
    methodWithNullableApiHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<io.vertx.reactivex.codegen.testmodel.RefedInterface1> rxMethodWithNullableApiHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableApiHandlerAsyncResult(notNull, $handler);
    });
  }

  public io.vertx.reactivex.codegen.testmodel.RefedInterface1 methodWithNullableApiReturn(boolean notNull) { 
    io.vertx.reactivex.codegen.testmodel.RefedInterface1 ret = io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)delegate.methodWithNullableApiReturn(notNull));
    return ret;
  }

  public boolean methodWithNonNullableDataObjectParam(io.vertx.codegen.testmodel.TestDataObject param) { 
    boolean ret = delegate.methodWithNonNullableDataObjectParam(param);
    return ret;
  }

  public void methodWithNullableDataObjectParam(boolean expectNull, io.vertx.codegen.testmodel.TestDataObject param) { 
    delegate.methodWithNullableDataObjectParam(expectNull, param);
  }

  public void methodWithNullableDataObjectHandler(boolean notNull, Handler<io.vertx.codegen.testmodel.TestDataObject> handler) { 
    delegate.methodWithNullableDataObjectHandler(notNull, handler);
  }

  public void methodWithNullableDataObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<io.vertx.codegen.testmodel.TestDataObject>> handler) { 
    delegate.methodWithNullableDataObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableDataObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableDataObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<io.vertx.codegen.testmodel.TestDataObject> rxMethodWithNullableDataObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableDataObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public io.vertx.codegen.testmodel.TestDataObject methodWithNullableDataObjectReturn(boolean notNull) { 
    io.vertx.codegen.testmodel.TestDataObject ret = delegate.methodWithNullableDataObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableJsonMappedParam(java.time.ZonedDateTime param) { 
    boolean ret = delegate.methodWithNonNullableJsonMappedParam(param);
    return ret;
  }

  public void methodWithNullableJsonMappedParam(boolean expectNull, java.time.ZonedDateTime param) { 
    delegate.methodWithNullableJsonMappedParam(expectNull, param);
  }

  public void methodWithNullableJsonMappedHandler(boolean notNull, Handler<java.time.ZonedDateTime> handler) { 
    delegate.methodWithNullableJsonMappedHandler(notNull, handler);
  }

  public void methodWithNullableJsonMappedHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.time.ZonedDateTime>> handler) { 
    delegate.methodWithNullableJsonMappedHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableJsonMappedHandlerAsyncResult(boolean notNull) {
    methodWithNullableJsonMappedHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.time.ZonedDateTime> rxMethodWithNullableJsonMappedHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableJsonMappedHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.time.ZonedDateTime methodWithNullableJsonMappedReturn(boolean notNull) { 
    java.time.ZonedDateTime ret = delegate.methodWithNullableJsonMappedReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableEnumParam(io.vertx.codegen.testmodel.TestEnum param) { 
    boolean ret = delegate.methodWithNonNullableEnumParam(param);
    return ret;
  }

  public void methodWithNullableEnumParam(boolean expectNull, io.vertx.codegen.testmodel.TestEnum param) { 
    delegate.methodWithNullableEnumParam(expectNull, param);
  }

  public void methodWithNullableEnumHandler(boolean notNull, Handler<io.vertx.codegen.testmodel.TestEnum> handler) { 
    delegate.methodWithNullableEnumHandler(notNull, handler);
  }

  public void methodWithNullableEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<io.vertx.codegen.testmodel.TestEnum>> handler) { 
    delegate.methodWithNullableEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<io.vertx.codegen.testmodel.TestEnum> rxMethodWithNullableEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public io.vertx.codegen.testmodel.TestEnum methodWithNullableEnumReturn(boolean notNull) { 
    io.vertx.codegen.testmodel.TestEnum ret = delegate.methodWithNullableEnumReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableGenEnumParam(io.vertx.codegen.testmodel.TestGenEnum param) { 
    boolean ret = delegate.methodWithNonNullableGenEnumParam(param);
    return ret;
  }

  public void methodWithNullableGenEnumParam(boolean expectNull, io.vertx.codegen.testmodel.TestGenEnum param) { 
    delegate.methodWithNullableGenEnumParam(expectNull, param);
  }

  public void methodWithNullableGenEnumHandler(boolean notNull, Handler<io.vertx.codegen.testmodel.TestGenEnum> handler) { 
    delegate.methodWithNullableGenEnumHandler(notNull, handler);
  }

  public void methodWithNullableGenEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<io.vertx.codegen.testmodel.TestGenEnum>> handler) { 
    delegate.methodWithNullableGenEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableGenEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableGenEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<io.vertx.codegen.testmodel.TestGenEnum> rxMethodWithNullableGenEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableGenEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public io.vertx.codegen.testmodel.TestGenEnum methodWithNullableGenEnumReturn(boolean notNull) { 
    io.vertx.codegen.testmodel.TestGenEnum ret = delegate.methodWithNullableGenEnumReturn(notNull);
    return ret;
  }

  public <T> void methodWithNullableTypeVariableParam(boolean expectNull, T param) { 
    delegate.methodWithNullableTypeVariableParam(expectNull, param);
  }

  public <T> void methodWithNullableTypeVariableHandler(boolean notNull, T value, Handler<T> handler) { 
    delegate.methodWithNullableTypeVariableHandler(notNull, value, handler);
  }

  public <T> void methodWithNullableTypeVariableHandlerAsyncResult(boolean notNull, T value, Handler<AsyncResult<T>> handler) { 
    delegate.methodWithNullableTypeVariableHandlerAsyncResult(notNull, value, handler);
  }

  public <T> void methodWithNullableTypeVariableHandlerAsyncResult(boolean notNull, T value) {
    methodWithNullableTypeVariableHandlerAsyncResult(notNull, value, ar -> { });
  }

  public <T> io.reactivex.Single<T> rxMethodWithNullableTypeVariableHandlerAsyncResult(boolean notNull, T value) { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithNullableTypeVariableHandlerAsyncResult(notNull, value, $handler);
    });
  }

  public <T> T methodWithNullableTypeVariableReturn(boolean notNull, T value) { 
    T ret = (T) delegate.methodWithNullableTypeVariableReturn(notNull, value);
    return ret;
  }

  public void methodWithNullableObjectParam(boolean expectNull, java.lang.Object param) { 
    delegate.methodWithNullableObjectParam(expectNull, param);
  }

  public boolean methodWithNonNullableListByteParam(List<Byte> param) { 
    boolean ret = delegate.methodWithNonNullableListByteParam(param);
    return ret;
  }

  public void methodWithNullableListByteParam(boolean expectNull, List<Byte> param) { 
    delegate.methodWithNullableListByteParam(expectNull, param);
  }

  public void methodWithNullableListByteHandler(boolean notNull, Handler<List<Byte>> handler) { 
    delegate.methodWithNullableListByteHandler(notNull, handler);
  }

  public void methodWithNullableListByteHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Byte>>> handler) { 
    delegate.methodWithNullableListByteHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListByteHandlerAsyncResult(boolean notNull) {
    methodWithNullableListByteHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Byte>> rxMethodWithNullableListByteHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListByteHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Byte> methodWithNullableListByteReturn(boolean notNull) { 
    List<Byte> ret = delegate.methodWithNullableListByteReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListShortParam(List<Short> param) { 
    boolean ret = delegate.methodWithNonNullableListShortParam(param);
    return ret;
  }

  public void methodWithNullableListShortParam(boolean expectNull, List<Short> param) { 
    delegate.methodWithNullableListShortParam(expectNull, param);
  }

  public void methodWithNullableListShortHandler(boolean notNull, Handler<List<Short>> handler) { 
    delegate.methodWithNullableListShortHandler(notNull, handler);
  }

  public void methodWithNullableListShortHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Short>>> handler) { 
    delegate.methodWithNullableListShortHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListShortHandlerAsyncResult(boolean notNull) {
    methodWithNullableListShortHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Short>> rxMethodWithNullableListShortHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListShortHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Short> methodWithNullableListShortReturn(boolean notNull) { 
    List<Short> ret = delegate.methodWithNullableListShortReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListIntegerParam(List<Integer> param) { 
    boolean ret = delegate.methodWithNonNullableListIntegerParam(param);
    return ret;
  }

  public void methodWithNullableListIntegerParam(boolean expectNull, List<Integer> param) { 
    delegate.methodWithNullableListIntegerParam(expectNull, param);
  }

  public void methodWithNullableListIntegerHandler(boolean notNull, Handler<List<Integer>> handler) { 
    delegate.methodWithNullableListIntegerHandler(notNull, handler);
  }

  public void methodWithNullableListIntegerHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Integer>>> handler) { 
    delegate.methodWithNullableListIntegerHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListIntegerHandlerAsyncResult(boolean notNull) {
    methodWithNullableListIntegerHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Integer>> rxMethodWithNullableListIntegerHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListIntegerHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Integer> methodWithNullableListIntegerReturn(boolean notNull) { 
    List<Integer> ret = delegate.methodWithNullableListIntegerReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListLongParam(List<Long> param) { 
    boolean ret = delegate.methodWithNonNullableListLongParam(param);
    return ret;
  }

  public void methodWithNullableListLongParam(boolean expectNull, List<Long> param) { 
    delegate.methodWithNullableListLongParam(expectNull, param);
  }

  public void methodWithNullableListLongHandler(boolean notNull, Handler<List<Long>> handler) { 
    delegate.methodWithNullableListLongHandler(notNull, handler);
  }

  public void methodWithNullableListLongHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Long>>> handler) { 
    delegate.methodWithNullableListLongHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListLongHandlerAsyncResult(boolean notNull) {
    methodWithNullableListLongHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Long>> rxMethodWithNullableListLongHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListLongHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Long> methodWithNullableListLongReturn(boolean notNull) { 
    List<Long> ret = delegate.methodWithNullableListLongReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListFloatParam(List<Float> param) { 
    boolean ret = delegate.methodWithNonNullableListFloatParam(param);
    return ret;
  }

  public void methodWithNullableListFloatParam(boolean expectNull, List<Float> param) { 
    delegate.methodWithNullableListFloatParam(expectNull, param);
  }

  public void methodWithNullableListFloatHandler(boolean notNull, Handler<List<Float>> handler) { 
    delegate.methodWithNullableListFloatHandler(notNull, handler);
  }

  public void methodWithNullableListFloatHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Float>>> handler) { 
    delegate.methodWithNullableListFloatHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListFloatHandlerAsyncResult(boolean notNull) {
    methodWithNullableListFloatHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Float>> rxMethodWithNullableListFloatHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListFloatHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Float> methodWithNullableListFloatReturn(boolean notNull) { 
    List<Float> ret = delegate.methodWithNullableListFloatReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListDoubleParam(List<Double> param) { 
    boolean ret = delegate.methodWithNonNullableListDoubleParam(param);
    return ret;
  }

  public void methodWithNullableListDoubleParam(boolean expectNull, List<Double> param) { 
    delegate.methodWithNullableListDoubleParam(expectNull, param);
  }

  public void methodWithNullableListDoubleHandler(boolean notNull, Handler<List<Double>> handler) { 
    delegate.methodWithNullableListDoubleHandler(notNull, handler);
  }

  public void methodWithNullableListDoubleHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Double>>> handler) { 
    delegate.methodWithNullableListDoubleHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListDoubleHandlerAsyncResult(boolean notNull) {
    methodWithNullableListDoubleHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Double>> rxMethodWithNullableListDoubleHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListDoubleHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Double> methodWithNullableListDoubleReturn(boolean notNull) { 
    List<Double> ret = delegate.methodWithNullableListDoubleReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListBooleanParam(List<Boolean> param) { 
    boolean ret = delegate.methodWithNonNullableListBooleanParam(param);
    return ret;
  }

  public void methodWithNullableListBooleanParam(boolean expectNull, List<Boolean> param) { 
    delegate.methodWithNullableListBooleanParam(expectNull, param);
  }

  public void methodWithNullableListBooleanHandler(boolean notNull, Handler<List<Boolean>> handler) { 
    delegate.methodWithNullableListBooleanHandler(notNull, handler);
  }

  public void methodWithNullableListBooleanHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Boolean>>> handler) { 
    delegate.methodWithNullableListBooleanHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListBooleanHandlerAsyncResult(boolean notNull) {
    methodWithNullableListBooleanHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Boolean>> rxMethodWithNullableListBooleanHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListBooleanHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Boolean> methodWithNullableListBooleanReturn(boolean notNull) { 
    List<Boolean> ret = delegate.methodWithNullableListBooleanReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListStringParam(List<String> param) { 
    boolean ret = delegate.methodWithNonNullableListStringParam(param);
    return ret;
  }

  public void methodWithNullableListStringParam(boolean expectNull, List<String> param) { 
    delegate.methodWithNullableListStringParam(expectNull, param);
  }

  public void methodWithNullableListStringHandler(boolean notNull, Handler<List<String>> handler) { 
    delegate.methodWithNullableListStringHandler(notNull, handler);
  }

  public void methodWithNullableListStringHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<String>>> handler) { 
    delegate.methodWithNullableListStringHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListStringHandlerAsyncResult(boolean notNull) {
    methodWithNullableListStringHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<String>> rxMethodWithNullableListStringHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListStringHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<String> methodWithNullableListStringReturn(boolean notNull) { 
    List<String> ret = delegate.methodWithNullableListStringReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListCharParam(List<Character> param) { 
    boolean ret = delegate.methodWithNonNullableListCharParam(param);
    return ret;
  }

  public void methodWithNullableListCharParam(boolean expectNull, List<Character> param) { 
    delegate.methodWithNullableListCharParam(expectNull, param);
  }

  public void methodWithNullableListCharHandler(boolean notNull, Handler<List<Character>> handler) { 
    delegate.methodWithNullableListCharHandler(notNull, handler);
  }

  public void methodWithNullableListCharHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<Character>>> handler) { 
    delegate.methodWithNullableListCharHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListCharHandlerAsyncResult(boolean notNull) {
    methodWithNullableListCharHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<Character>> rxMethodWithNullableListCharHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListCharHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<Character> methodWithNullableListCharReturn(boolean notNull) { 
    List<Character> ret = delegate.methodWithNullableListCharReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListJsonObjectParam(List<JsonObject> param) { 
    boolean ret = delegate.methodWithNonNullableListJsonObjectParam(param);
    return ret;
  }

  public void methodWithNullableListJsonObjectParam(boolean expectNull, List<JsonObject> param) { 
    delegate.methodWithNullableListJsonObjectParam(expectNull, param);
  }

  public void methodWithNullableListJsonObjectHandler(boolean notNull, Handler<List<JsonObject>> handler) { 
    delegate.methodWithNullableListJsonObjectHandler(notNull, handler);
  }

  public void methodWithNullableListJsonObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<JsonObject>>> handler) { 
    delegate.methodWithNullableListJsonObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListJsonObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableListJsonObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<JsonObject>> rxMethodWithNullableListJsonObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListJsonObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<JsonObject> methodWithNullableListJsonObjectReturn(boolean notNull) { 
    List<JsonObject> ret = delegate.methodWithNullableListJsonObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListJsonArrayParam(List<JsonArray> param) { 
    boolean ret = delegate.methodWithNonNullableListJsonArrayParam(param);
    return ret;
  }

  public void methodWithNullableListJsonArrayParam(boolean expectNull, List<JsonArray> param) { 
    delegate.methodWithNullableListJsonArrayParam(expectNull, param);
  }

  public void methodWithNullableListJsonArrayHandler(boolean notNull, Handler<List<JsonArray>> handler) { 
    delegate.methodWithNullableListJsonArrayHandler(notNull, handler);
  }

  public void methodWithNullableListJsonArrayHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<JsonArray>>> handler) { 
    delegate.methodWithNullableListJsonArrayHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListJsonArrayHandlerAsyncResult(boolean notNull) {
    methodWithNullableListJsonArrayHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<JsonArray>> rxMethodWithNullableListJsonArrayHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListJsonArrayHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<JsonArray> methodWithNullableListJsonArrayReturn(boolean notNull) { 
    List<JsonArray> ret = delegate.methodWithNullableListJsonArrayReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListApiParam(List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    boolean ret = delegate.methodWithNonNullableListApiParam(param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toList()));
    return ret;
  }

  public void methodWithNullableListApiParam(boolean expectNull, List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithNullableListApiParam(expectNull, param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toList()));
  }

  public void methodWithNullableListApiHandler(boolean notNull, Handler<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithNullableListApiHandler(notNull, new Handler<List<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(List<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList()));
      }
    });
  }

  public void methodWithNullableListApiHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithNullableListApiHandlerAsyncResult(notNull, new Handler<AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithNullableListApiHandlerAsyncResult(boolean notNull) {
    methodWithNullableListApiHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithNullableListApiHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListApiHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithNullableListApiReturn(boolean notNull) { 
    List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithNullableListApiReturn(notNull).stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList());
    return ret;
  }

  public boolean methodWithNonNullableListDataObjectParam(List<io.vertx.codegen.testmodel.TestDataObject> param) { 
    boolean ret = delegate.methodWithNonNullableListDataObjectParam(param);
    return ret;
  }

  public void methodWithNullableListDataObjectParam(boolean expectNull, List<io.vertx.codegen.testmodel.TestDataObject> param) { 
    delegate.methodWithNullableListDataObjectParam(expectNull, param);
  }

  public void methodWithNullableListDataObjectHandler(boolean notNull, Handler<List<io.vertx.codegen.testmodel.TestDataObject>> handler) { 
    delegate.methodWithNullableListDataObjectHandler(notNull, handler);
  }

  public void methodWithNullableListDataObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestDataObject>>> handler) { 
    delegate.methodWithNullableListDataObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListDataObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableListDataObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithNullableListDataObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListDataObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestDataObject> methodWithNullableListDataObjectReturn(boolean notNull) { 
    List<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithNullableListDataObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListEnumParam(List<io.vertx.codegen.testmodel.TestEnum> param) { 
    boolean ret = delegate.methodWithNonNullableListEnumParam(param);
    return ret;
  }

  public void methodWithNullableListEnumParam(boolean expectNull, List<io.vertx.codegen.testmodel.TestEnum> param) { 
    delegate.methodWithNullableListEnumParam(expectNull, param);
  }

  public void methodWithNullableListEnumHandler(boolean notNull, Handler<List<io.vertx.codegen.testmodel.TestEnum>> handler) { 
    delegate.methodWithNullableListEnumHandler(notNull, handler);
  }

  public void methodWithNullableListEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestEnum>>> handler) { 
    delegate.methodWithNullableListEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableListEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithNullableListEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestEnum> methodWithNullableListEnumReturn(boolean notNull) { 
    List<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithNullableListEnumReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableListGenEnumParam(List<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    boolean ret = delegate.methodWithNonNullableListGenEnumParam(param);
    return ret;
  }

  public void methodWithNullableListGenEnumParam(boolean expectNull, List<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    delegate.methodWithNullableListGenEnumParam(expectNull, param);
  }

  public void methodWithNullableListGenEnumHandler(boolean notNull, Handler<List<io.vertx.codegen.testmodel.TestGenEnum>> handler) { 
    delegate.methodWithNullableListGenEnumHandler(notNull, handler);
  }

  public void methodWithNullableListGenEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestGenEnum>>> handler) { 
    delegate.methodWithNullableListGenEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableListGenEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableListGenEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<List<io.vertx.codegen.testmodel.TestGenEnum>> rxMethodWithNullableListGenEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableListGenEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestGenEnum> methodWithNullableListGenEnumReturn(boolean notNull) { 
    List<io.vertx.codegen.testmodel.TestGenEnum> ret = delegate.methodWithNullableListGenEnumReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetByteParam(Set<Byte> param) { 
    boolean ret = delegate.methodWithNonNullableSetByteParam(param);
    return ret;
  }

  public void methodWithNullableSetByteParam(boolean expectNull, Set<Byte> param) { 
    delegate.methodWithNullableSetByteParam(expectNull, param);
  }

  public void methodWithNullableSetByteHandler(boolean notNull, Handler<Set<Byte>> handler) { 
    delegate.methodWithNullableSetByteHandler(notNull, handler);
  }

  public void methodWithNullableSetByteHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Byte>>> handler) { 
    delegate.methodWithNullableSetByteHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetByteHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetByteHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Byte>> rxMethodWithNullableSetByteHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetByteHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Byte> methodWithNullableSetByteReturn(boolean notNull) { 
    Set<Byte> ret = delegate.methodWithNullableSetByteReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetShortParam(Set<Short> param) { 
    boolean ret = delegate.methodWithNonNullableSetShortParam(param);
    return ret;
  }

  public void methodWithNullableSetShortParam(boolean expectNull, Set<Short> param) { 
    delegate.methodWithNullableSetShortParam(expectNull, param);
  }

  public void methodWithNullableSetShortHandler(boolean notNull, Handler<Set<Short>> handler) { 
    delegate.methodWithNullableSetShortHandler(notNull, handler);
  }

  public void methodWithNullableSetShortHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Short>>> handler) { 
    delegate.methodWithNullableSetShortHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetShortHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetShortHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Short>> rxMethodWithNullableSetShortHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetShortHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Short> methodWithNullableSetShortReturn(boolean notNull) { 
    Set<Short> ret = delegate.methodWithNullableSetShortReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetIntegerParam(Set<Integer> param) { 
    boolean ret = delegate.methodWithNonNullableSetIntegerParam(param);
    return ret;
  }

  public void methodWithNullableSetIntegerParam(boolean expectNull, Set<Integer> param) { 
    delegate.methodWithNullableSetIntegerParam(expectNull, param);
  }

  public void methodWithNullableSetIntegerHandler(boolean notNull, Handler<Set<Integer>> handler) { 
    delegate.methodWithNullableSetIntegerHandler(notNull, handler);
  }

  public void methodWithNullableSetIntegerHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Integer>>> handler) { 
    delegate.methodWithNullableSetIntegerHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetIntegerHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetIntegerHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Integer>> rxMethodWithNullableSetIntegerHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetIntegerHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Integer> methodWithNullableSetIntegerReturn(boolean notNull) { 
    Set<Integer> ret = delegate.methodWithNullableSetIntegerReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetLongParam(Set<Long> param) { 
    boolean ret = delegate.methodWithNonNullableSetLongParam(param);
    return ret;
  }

  public void methodWithNullableSetLongParam(boolean expectNull, Set<Long> param) { 
    delegate.methodWithNullableSetLongParam(expectNull, param);
  }

  public void methodWithNullableSetLongHandler(boolean notNull, Handler<Set<Long>> handler) { 
    delegate.methodWithNullableSetLongHandler(notNull, handler);
  }

  public void methodWithNullableSetLongHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Long>>> handler) { 
    delegate.methodWithNullableSetLongHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetLongHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetLongHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Long>> rxMethodWithNullableSetLongHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetLongHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Long> methodWithNullableSetLongReturn(boolean notNull) { 
    Set<Long> ret = delegate.methodWithNullableSetLongReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetFloatParam(Set<Float> param) { 
    boolean ret = delegate.methodWithNonNullableSetFloatParam(param);
    return ret;
  }

  public void methodWithNullableSetFloatParam(boolean expectNull, Set<Float> param) { 
    delegate.methodWithNullableSetFloatParam(expectNull, param);
  }

  public void methodWithNullableSetFloatHandler(boolean notNull, Handler<Set<Float>> handler) { 
    delegate.methodWithNullableSetFloatHandler(notNull, handler);
  }

  public void methodWithNullableSetFloatHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Float>>> handler) { 
    delegate.methodWithNullableSetFloatHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetFloatHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetFloatHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Float>> rxMethodWithNullableSetFloatHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetFloatHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Float> methodWithNullableSetFloatReturn(boolean notNull) { 
    Set<Float> ret = delegate.methodWithNullableSetFloatReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetDoubleParam(Set<Double> param) { 
    boolean ret = delegate.methodWithNonNullableSetDoubleParam(param);
    return ret;
  }

  public void methodWithNullableSetDoubleParam(boolean expectNull, Set<Double> param) { 
    delegate.methodWithNullableSetDoubleParam(expectNull, param);
  }

  public void methodWithNullableSetDoubleHandler(boolean notNull, Handler<Set<Double>> handler) { 
    delegate.methodWithNullableSetDoubleHandler(notNull, handler);
  }

  public void methodWithNullableSetDoubleHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Double>>> handler) { 
    delegate.methodWithNullableSetDoubleHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetDoubleHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetDoubleHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Double>> rxMethodWithNullableSetDoubleHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetDoubleHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Double> methodWithNullableSetDoubleReturn(boolean notNull) { 
    Set<Double> ret = delegate.methodWithNullableSetDoubleReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetBooleanParam(Set<Boolean> param) { 
    boolean ret = delegate.methodWithNonNullableSetBooleanParam(param);
    return ret;
  }

  public void methodWithNullableSetBooleanParam(boolean expectNull, Set<Boolean> param) { 
    delegate.methodWithNullableSetBooleanParam(expectNull, param);
  }

  public void methodWithNullableSetBooleanHandler(boolean notNull, Handler<Set<Boolean>> handler) { 
    delegate.methodWithNullableSetBooleanHandler(notNull, handler);
  }

  public void methodWithNullableSetBooleanHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Boolean>>> handler) { 
    delegate.methodWithNullableSetBooleanHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetBooleanHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetBooleanHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Boolean>> rxMethodWithNullableSetBooleanHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetBooleanHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Boolean> methodWithNullableSetBooleanReturn(boolean notNull) { 
    Set<Boolean> ret = delegate.methodWithNullableSetBooleanReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetStringParam(Set<String> param) { 
    boolean ret = delegate.methodWithNonNullableSetStringParam(param);
    return ret;
  }

  public void methodWithNullableSetStringParam(boolean expectNull, Set<String> param) { 
    delegate.methodWithNullableSetStringParam(expectNull, param);
  }

  public void methodWithNullableSetStringHandler(boolean notNull, Handler<Set<String>> handler) { 
    delegate.methodWithNullableSetStringHandler(notNull, handler);
  }

  public void methodWithNullableSetStringHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<String>>> handler) { 
    delegate.methodWithNullableSetStringHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetStringHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetStringHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<String>> rxMethodWithNullableSetStringHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetStringHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<String> methodWithNullableSetStringReturn(boolean notNull) { 
    Set<String> ret = delegate.methodWithNullableSetStringReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetCharParam(Set<Character> param) { 
    boolean ret = delegate.methodWithNonNullableSetCharParam(param);
    return ret;
  }

  public void methodWithNullableSetCharParam(boolean expectNull, Set<Character> param) { 
    delegate.methodWithNullableSetCharParam(expectNull, param);
  }

  public void methodWithNullableSetCharHandler(boolean notNull, Handler<Set<Character>> handler) { 
    delegate.methodWithNullableSetCharHandler(notNull, handler);
  }

  public void methodWithNullableSetCharHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<Character>>> handler) { 
    delegate.methodWithNullableSetCharHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetCharHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetCharHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<Character>> rxMethodWithNullableSetCharHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetCharHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<Character> methodWithNullableSetCharReturn(boolean notNull) { 
    Set<Character> ret = delegate.methodWithNullableSetCharReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetJsonObjectParam(Set<JsonObject> param) { 
    boolean ret = delegate.methodWithNonNullableSetJsonObjectParam(param);
    return ret;
  }

  public void methodWithNullableSetJsonObjectParam(boolean expectNull, Set<JsonObject> param) { 
    delegate.methodWithNullableSetJsonObjectParam(expectNull, param);
  }

  public void methodWithNullableSetJsonObjectHandler(boolean notNull, Handler<Set<JsonObject>> handler) { 
    delegate.methodWithNullableSetJsonObjectHandler(notNull, handler);
  }

  public void methodWithNullableSetJsonObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<JsonObject>>> handler) { 
    delegate.methodWithNullableSetJsonObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetJsonObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetJsonObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<JsonObject>> rxMethodWithNullableSetJsonObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetJsonObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<JsonObject> methodWithNullableSetJsonObjectReturn(boolean notNull) { 
    Set<JsonObject> ret = delegate.methodWithNullableSetJsonObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetJsonArrayParam(Set<JsonArray> param) { 
    boolean ret = delegate.methodWithNonNullableSetJsonArrayParam(param);
    return ret;
  }

  public void methodWithNullableSetJsonArrayParam(boolean expectNull, Set<JsonArray> param) { 
    delegate.methodWithNullableSetJsonArrayParam(expectNull, param);
  }

  public void methodWithNullableSetJsonArrayHandler(boolean notNull, Handler<Set<JsonArray>> handler) { 
    delegate.methodWithNullableSetJsonArrayHandler(notNull, handler);
  }

  public void methodWithNullableSetJsonArrayHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<JsonArray>>> handler) { 
    delegate.methodWithNullableSetJsonArrayHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetJsonArrayHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetJsonArrayHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<JsonArray>> rxMethodWithNullableSetJsonArrayHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetJsonArrayHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<JsonArray> methodWithNullableSetJsonArrayReturn(boolean notNull) { 
    Set<JsonArray> ret = delegate.methodWithNullableSetJsonArrayReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetApiParam(Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    boolean ret = delegate.methodWithNonNullableSetApiParam(param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toSet()));
    return ret;
  }

  public void methodWithNullableSetApiParam(boolean expectNull, Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithNullableSetApiParam(expectNull, param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toSet()));
  }

  public void methodWithNullableSetApiHandler(boolean notNull, Handler<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithNullableSetApiHandler(notNull, new Handler<Set<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(Set<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet()));
      }
    });
  }

  public void methodWithNullableSetApiHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithNullableSetApiHandlerAsyncResult(notNull, new Handler<AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithNullableSetApiHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetApiHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithNullableSetApiHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetApiHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithNullableSetApiReturn(boolean notNull) { 
    Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithNullableSetApiReturn(notNull).stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet());
    return ret;
  }

  public boolean methodWithNonNullableSetDataObjectParam(Set<io.vertx.codegen.testmodel.TestDataObject> param) { 
    boolean ret = delegate.methodWithNonNullableSetDataObjectParam(param);
    return ret;
  }

  public void methodWithNullableSetDataObjectParam(boolean expectNull, Set<io.vertx.codegen.testmodel.TestDataObject> param) { 
    delegate.methodWithNullableSetDataObjectParam(expectNull, param);
  }

  public void methodWithNullableSetDataObjectHandler(boolean notNull, Handler<Set<io.vertx.codegen.testmodel.TestDataObject>> handler) { 
    delegate.methodWithNullableSetDataObjectHandler(notNull, handler);
  }

  public void methodWithNullableSetDataObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestDataObject>>> handler) { 
    delegate.methodWithNullableSetDataObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetDataObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetDataObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithNullableSetDataObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetDataObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestDataObject> methodWithNullableSetDataObjectReturn(boolean notNull) { 
    Set<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithNullableSetDataObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetEnumParam(Set<io.vertx.codegen.testmodel.TestEnum> param) { 
    boolean ret = delegate.methodWithNonNullableSetEnumParam(param);
    return ret;
  }

  public void methodWithNullableSetEnumParam(boolean expectNull, Set<io.vertx.codegen.testmodel.TestEnum> param) { 
    delegate.methodWithNullableSetEnumParam(expectNull, param);
  }

  public void methodWithNullableSetEnumHandler(boolean notNull, Handler<Set<io.vertx.codegen.testmodel.TestEnum>> handler) { 
    delegate.methodWithNullableSetEnumHandler(notNull, handler);
  }

  public void methodWithNullableSetEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestEnum>>> handler) { 
    delegate.methodWithNullableSetEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithNullableSetEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestEnum> methodWithNullableSetEnumReturn(boolean notNull) { 
    Set<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithNullableSetEnumReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableSetGenEnumParam(Set<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    boolean ret = delegate.methodWithNonNullableSetGenEnumParam(param);
    return ret;
  }

  public void methodWithNullableSetGenEnumParam(boolean expectNull, Set<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    delegate.methodWithNullableSetGenEnumParam(expectNull, param);
  }

  public void methodWithNullableSetGenEnumHandler(boolean notNull, Handler<Set<io.vertx.codegen.testmodel.TestGenEnum>> handler) { 
    delegate.methodWithNullableSetGenEnumHandler(notNull, handler);
  }

  public void methodWithNullableSetGenEnumHandlerAsyncResult(boolean notNull, Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestGenEnum>>> handler) { 
    delegate.methodWithNullableSetGenEnumHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableSetGenEnumHandlerAsyncResult(boolean notNull) {
    methodWithNullableSetGenEnumHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<Set<io.vertx.codegen.testmodel.TestGenEnum>> rxMethodWithNullableSetGenEnumHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableSetGenEnumHandlerAsyncResult(notNull, $handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestGenEnum> methodWithNullableSetGenEnumReturn(boolean notNull) { 
    Set<io.vertx.codegen.testmodel.TestGenEnum> ret = delegate.methodWithNullableSetGenEnumReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapByteParam(java.util.Map<String, Byte> param) { 
    boolean ret = delegate.methodWithNonNullableMapByteParam(param);
    return ret;
  }

  public void methodWithNullableMapByteParam(boolean expectNull, java.util.Map<String, Byte> param) { 
    delegate.methodWithNullableMapByteParam(expectNull, param);
  }

  public void methodWithNullableMapByteHandler(boolean notNull, Handler<java.util.Map<String, Byte>> handler) { 
    delegate.methodWithNullableMapByteHandler(notNull, handler);
  }

  public void methodWithNullableMapByteHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Byte>>> handler) { 
    delegate.methodWithNullableMapByteHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapByteHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapByteHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Byte>> rxMethodWithNullableMapByteHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapByteHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Byte> methodWithNullableMapByteReturn(boolean notNull) { 
    java.util.Map<String, Byte> ret = delegate.methodWithNullableMapByteReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapShortParam(java.util.Map<String, Short> param) { 
    boolean ret = delegate.methodWithNonNullableMapShortParam(param);
    return ret;
  }

  public void methodWithNullableMapShortParam(boolean expectNull, java.util.Map<String, Short> param) { 
    delegate.methodWithNullableMapShortParam(expectNull, param);
  }

  public void methodWithNullableMapShortHandler(boolean notNull, Handler<java.util.Map<String, Short>> handler) { 
    delegate.methodWithNullableMapShortHandler(notNull, handler);
  }

  public void methodWithNullableMapShortHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Short>>> handler) { 
    delegate.methodWithNullableMapShortHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapShortHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapShortHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Short>> rxMethodWithNullableMapShortHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapShortHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Short> methodWithNullableMapShortReturn(boolean notNull) { 
    java.util.Map<String, Short> ret = delegate.methodWithNullableMapShortReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapIntegerParam(java.util.Map<String, Integer> param) { 
    boolean ret = delegate.methodWithNonNullableMapIntegerParam(param);
    return ret;
  }

  public void methodWithNullableMapIntegerParam(boolean expectNull, java.util.Map<String, Integer> param) { 
    delegate.methodWithNullableMapIntegerParam(expectNull, param);
  }

  public void methodWithNullableMapIntegerHandler(boolean notNull, Handler<java.util.Map<String, Integer>> handler) { 
    delegate.methodWithNullableMapIntegerHandler(notNull, handler);
  }

  public void methodWithNullableMapIntegerHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Integer>>> handler) { 
    delegate.methodWithNullableMapIntegerHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapIntegerHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapIntegerHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Integer>> rxMethodWithNullableMapIntegerHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapIntegerHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Integer> methodWithNullableMapIntegerReturn(boolean notNull) { 
    java.util.Map<String, Integer> ret = delegate.methodWithNullableMapIntegerReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapLongParam(java.util.Map<String, Long> param) { 
    boolean ret = delegate.methodWithNonNullableMapLongParam(param);
    return ret;
  }

  public void methodWithNullableMapLongParam(boolean expectNull, java.util.Map<String, Long> param) { 
    delegate.methodWithNullableMapLongParam(expectNull, param);
  }

  public void methodWithNullableMapLongHandler(boolean notNull, Handler<java.util.Map<String, Long>> handler) { 
    delegate.methodWithNullableMapLongHandler(notNull, handler);
  }

  public void methodWithNullableMapLongHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Long>>> handler) { 
    delegate.methodWithNullableMapLongHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapLongHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapLongHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Long>> rxMethodWithNullableMapLongHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapLongHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Long> methodWithNullableMapLongReturn(boolean notNull) { 
    java.util.Map<String, Long> ret = delegate.methodWithNullableMapLongReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapFloatParam(java.util.Map<String, Float> param) { 
    boolean ret = delegate.methodWithNonNullableMapFloatParam(param);
    return ret;
  }

  public void methodWithNullableMapFloatParam(boolean expectNull, java.util.Map<String, Float> param) { 
    delegate.methodWithNullableMapFloatParam(expectNull, param);
  }

  public void methodWithNullableMapFloatHandler(boolean notNull, Handler<java.util.Map<String, Float>> handler) { 
    delegate.methodWithNullableMapFloatHandler(notNull, handler);
  }

  public void methodWithNullableMapFloatHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Float>>> handler) { 
    delegate.methodWithNullableMapFloatHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapFloatHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapFloatHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Float>> rxMethodWithNullableMapFloatHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapFloatHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Float> methodWithNullableMapFloatReturn(boolean notNull) { 
    java.util.Map<String, Float> ret = delegate.methodWithNullableMapFloatReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapDoubleParam(java.util.Map<String, Double> param) { 
    boolean ret = delegate.methodWithNonNullableMapDoubleParam(param);
    return ret;
  }

  public void methodWithNullableMapDoubleParam(boolean expectNull, java.util.Map<String, Double> param) { 
    delegate.methodWithNullableMapDoubleParam(expectNull, param);
  }

  public void methodWithNullableMapDoubleHandler(boolean notNull, Handler<java.util.Map<String, Double>> handler) { 
    delegate.methodWithNullableMapDoubleHandler(notNull, handler);
  }

  public void methodWithNullableMapDoubleHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Double>>> handler) { 
    delegate.methodWithNullableMapDoubleHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapDoubleHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapDoubleHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Double>> rxMethodWithNullableMapDoubleHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapDoubleHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Double> methodWithNullableMapDoubleReturn(boolean notNull) { 
    java.util.Map<String, Double> ret = delegate.methodWithNullableMapDoubleReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapBooleanParam(java.util.Map<String, Boolean> param) { 
    boolean ret = delegate.methodWithNonNullableMapBooleanParam(param);
    return ret;
  }

  public void methodWithNullableMapBooleanParam(boolean expectNull, java.util.Map<String, Boolean> param) { 
    delegate.methodWithNullableMapBooleanParam(expectNull, param);
  }

  public void methodWithNullableMapBooleanHandler(boolean notNull, Handler<java.util.Map<String, Boolean>> handler) { 
    delegate.methodWithNullableMapBooleanHandler(notNull, handler);
  }

  public void methodWithNullableMapBooleanHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Boolean>>> handler) { 
    delegate.methodWithNullableMapBooleanHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapBooleanHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapBooleanHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Boolean>> rxMethodWithNullableMapBooleanHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapBooleanHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Boolean> methodWithNullableMapBooleanReturn(boolean notNull) { 
    java.util.Map<String, Boolean> ret = delegate.methodWithNullableMapBooleanReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapStringParam(java.util.Map<String, String> param) { 
    boolean ret = delegate.methodWithNonNullableMapStringParam(param);
    return ret;
  }

  public void methodWithNullableMapStringParam(boolean expectNull, java.util.Map<String, String> param) { 
    delegate.methodWithNullableMapStringParam(expectNull, param);
  }

  public void methodWithNullableMapStringHandler(boolean notNull, Handler<java.util.Map<String, String>> handler) { 
    delegate.methodWithNullableMapStringHandler(notNull, handler);
  }

  public void methodWithNullableMapStringHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, String>>> handler) { 
    delegate.methodWithNullableMapStringHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapStringHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapStringHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, String>> rxMethodWithNullableMapStringHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapStringHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, String> methodWithNullableMapStringReturn(boolean notNull) { 
    java.util.Map<String, String> ret = delegate.methodWithNullableMapStringReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapCharParam(java.util.Map<String, Character> param) { 
    boolean ret = delegate.methodWithNonNullableMapCharParam(param);
    return ret;
  }

  public void methodWithNullableMapCharParam(boolean expectNull, java.util.Map<String, Character> param) { 
    delegate.methodWithNullableMapCharParam(expectNull, param);
  }

  public void methodWithNullableMapCharHandler(boolean notNull, Handler<java.util.Map<String, Character>> handler) { 
    delegate.methodWithNullableMapCharHandler(notNull, handler);
  }

  public void methodWithNullableMapCharHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, Character>>> handler) { 
    delegate.methodWithNullableMapCharHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapCharHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapCharHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, Character>> rxMethodWithNullableMapCharHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapCharHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, Character> methodWithNullableMapCharReturn(boolean notNull) { 
    java.util.Map<String, Character> ret = delegate.methodWithNullableMapCharReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapJsonObjectParam(java.util.Map<String, JsonObject> param) { 
    boolean ret = delegate.methodWithNonNullableMapJsonObjectParam(param);
    return ret;
  }

  public void methodWithNullableMapJsonObjectParam(boolean expectNull, java.util.Map<String, JsonObject> param) { 
    delegate.methodWithNullableMapJsonObjectParam(expectNull, param);
  }

  public void methodWithNullableMapJsonObjectHandler(boolean notNull, Handler<java.util.Map<String, JsonObject>> handler) { 
    delegate.methodWithNullableMapJsonObjectHandler(notNull, handler);
  }

  public void methodWithNullableMapJsonObjectHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, JsonObject>>> handler) { 
    delegate.methodWithNullableMapJsonObjectHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapJsonObjectHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapJsonObjectHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, JsonObject>> rxMethodWithNullableMapJsonObjectHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapJsonObjectHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, JsonObject> methodWithNullableMapJsonObjectReturn(boolean notNull) { 
    java.util.Map<String, JsonObject> ret = delegate.methodWithNullableMapJsonObjectReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapJsonArrayParam(java.util.Map<String, JsonArray> param) { 
    boolean ret = delegate.methodWithNonNullableMapJsonArrayParam(param);
    return ret;
  }

  public void methodWithNullableMapJsonArrayParam(boolean expectNull, java.util.Map<String, JsonArray> param) { 
    delegate.methodWithNullableMapJsonArrayParam(expectNull, param);
  }

  public void methodWithNullableMapJsonArrayHandler(boolean notNull, Handler<java.util.Map<String, JsonArray>> handler) { 
    delegate.methodWithNullableMapJsonArrayHandler(notNull, handler);
  }

  public void methodWithNullableMapJsonArrayHandlerAsyncResult(boolean notNull, Handler<AsyncResult<java.util.Map<String, JsonArray>>> handler) { 
    delegate.methodWithNullableMapJsonArrayHandlerAsyncResult(notNull, handler);
  }

  public void methodWithNullableMapJsonArrayHandlerAsyncResult(boolean notNull) {
    methodWithNullableMapJsonArrayHandlerAsyncResult(notNull, ar -> { });
  }

  public io.reactivex.Maybe<java.util.Map<String, JsonArray>> rxMethodWithNullableMapJsonArrayHandlerAsyncResult(boolean notNull) { 
    return AsyncResultMaybe.toMaybe($handler -> {
      methodWithNullableMapJsonArrayHandlerAsyncResult(notNull, $handler);
    });
  }

  public java.util.Map<String, JsonArray> methodWithNullableMapJsonArrayReturn(boolean notNull) { 
    java.util.Map<String, JsonArray> ret = delegate.methodWithNullableMapJsonArrayReturn(notNull);
    return ret;
  }

  public boolean methodWithNonNullableMapApiParam(java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    boolean ret = delegate.methodWithNonNullableMapApiParam(param.entrySet().stream().collect(Collectors.toMap(e -> e.getKey(), e -> e.getValue().getDelegate())));
    return ret;
  }

  public void methodWithNullableMapApiParam(boolean expectNull, java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithNullableMapApiParam(expectNull, param.entrySet().stream().collect(Collectors.toMap(e -> e.getKey(), e -> e.getValue().getDelegate())));
  }

  public void methodWithListNullableByteParam(List<Byte> param) { 
    delegate.methodWithListNullableByteParam(param);
  }

  public void methodWithListNullableByteHandler(Handler<List<Byte>> handler) { 
    delegate.methodWithListNullableByteHandler(handler);
  }

  public void methodWithListNullableByteHandlerAsyncResult(Handler<AsyncResult<List<Byte>>> handler) { 
    delegate.methodWithListNullableByteHandlerAsyncResult(handler);
  }

  public void methodWithListNullableByteHandlerAsyncResult() {
    methodWithListNullableByteHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Byte>> rxMethodWithListNullableByteHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableByteHandlerAsyncResult($handler);
    });
  }

  public List<Byte> methodWithListNullableByteReturn() { 
    List<Byte> ret = delegate.methodWithListNullableByteReturn();
    return ret;
  }

  public void methodWithListNullableShortParam(List<Short> param) { 
    delegate.methodWithListNullableShortParam(param);
  }

  public void methodWithListNullableShortHandler(Handler<List<Short>> handler) { 
    delegate.methodWithListNullableShortHandler(handler);
  }

  public void methodWithListNullableShortHandlerAsyncResult(Handler<AsyncResult<List<Short>>> handler) { 
    delegate.methodWithListNullableShortHandlerAsyncResult(handler);
  }

  public void methodWithListNullableShortHandlerAsyncResult() {
    methodWithListNullableShortHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Short>> rxMethodWithListNullableShortHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableShortHandlerAsyncResult($handler);
    });
  }

  public List<Short> methodWithListNullableShortReturn() { 
    List<Short> ret = delegate.methodWithListNullableShortReturn();
    return ret;
  }

  public void methodWithListNullableIntegerParam(List<Integer> param) { 
    delegate.methodWithListNullableIntegerParam(param);
  }

  public void methodWithListNullableIntegerHandler(Handler<List<Integer>> handler) { 
    delegate.methodWithListNullableIntegerHandler(handler);
  }

  public void methodWithListNullableIntegerHandlerAsyncResult(Handler<AsyncResult<List<Integer>>> handler) { 
    delegate.methodWithListNullableIntegerHandlerAsyncResult(handler);
  }

  public void methodWithListNullableIntegerHandlerAsyncResult() {
    methodWithListNullableIntegerHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Integer>> rxMethodWithListNullableIntegerHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableIntegerHandlerAsyncResult($handler);
    });
  }

  public List<Integer> methodWithListNullableIntegerReturn() { 
    List<Integer> ret = delegate.methodWithListNullableIntegerReturn();
    return ret;
  }

  public void methodWithListNullableLongParam(List<Long> param) { 
    delegate.methodWithListNullableLongParam(param);
  }

  public void methodWithListNullableLongHandler(Handler<List<Long>> handler) { 
    delegate.methodWithListNullableLongHandler(handler);
  }

  public void methodWithListNullableLongHandlerAsyncResult(Handler<AsyncResult<List<Long>>> handler) { 
    delegate.methodWithListNullableLongHandlerAsyncResult(handler);
  }

  public void methodWithListNullableLongHandlerAsyncResult() {
    methodWithListNullableLongHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Long>> rxMethodWithListNullableLongHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableLongHandlerAsyncResult($handler);
    });
  }

  public List<Long> methodWithListNullableLongReturn() { 
    List<Long> ret = delegate.methodWithListNullableLongReturn();
    return ret;
  }

  public void methodWithListNullableBooleanParam(List<Boolean> param) { 
    delegate.methodWithListNullableBooleanParam(param);
  }

  public void methodWithListNullableBooleanHandler(Handler<List<Boolean>> handler) { 
    delegate.methodWithListNullableBooleanHandler(handler);
  }

  public void methodWithListNullableBooleanHandlerAsyncResult(Handler<AsyncResult<List<Boolean>>> handler) { 
    delegate.methodWithListNullableBooleanHandlerAsyncResult(handler);
  }

  public void methodWithListNullableBooleanHandlerAsyncResult() {
    methodWithListNullableBooleanHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Boolean>> rxMethodWithListNullableBooleanHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableBooleanHandlerAsyncResult($handler);
    });
  }

  public List<Boolean> methodWithListNullableBooleanReturn() { 
    List<Boolean> ret = delegate.methodWithListNullableBooleanReturn();
    return ret;
  }

  public void methodWithListNullableFloatParam(List<Float> param) { 
    delegate.methodWithListNullableFloatParam(param);
  }

  public void methodWithListNullableFloatHandler(Handler<List<Float>> handler) { 
    delegate.methodWithListNullableFloatHandler(handler);
  }

  public void methodWithListNullableFloatHandlerAsyncResult(Handler<AsyncResult<List<Float>>> handler) { 
    delegate.methodWithListNullableFloatHandlerAsyncResult(handler);
  }

  public void methodWithListNullableFloatHandlerAsyncResult() {
    methodWithListNullableFloatHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Float>> rxMethodWithListNullableFloatHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableFloatHandlerAsyncResult($handler);
    });
  }

  public List<Float> methodWithListNullableFloatReturn() { 
    List<Float> ret = delegate.methodWithListNullableFloatReturn();
    return ret;
  }

  public void methodWithListNullableDoubleParam(List<Double> param) { 
    delegate.methodWithListNullableDoubleParam(param);
  }

  public void methodWithListNullableDoubleHandler(Handler<List<Double>> handler) { 
    delegate.methodWithListNullableDoubleHandler(handler);
  }

  public void methodWithListNullableDoubleHandlerAsyncResult(Handler<AsyncResult<List<Double>>> handler) { 
    delegate.methodWithListNullableDoubleHandlerAsyncResult(handler);
  }

  public void methodWithListNullableDoubleHandlerAsyncResult() {
    methodWithListNullableDoubleHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Double>> rxMethodWithListNullableDoubleHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableDoubleHandlerAsyncResult($handler);
    });
  }

  public List<Double> methodWithListNullableDoubleReturn() { 
    List<Double> ret = delegate.methodWithListNullableDoubleReturn();
    return ret;
  }

  public void methodWithListNullableStringParam(List<String> param) { 
    delegate.methodWithListNullableStringParam(param);
  }

  public void methodWithListNullableStringHandler(Handler<List<String>> handler) { 
    delegate.methodWithListNullableStringHandler(handler);
  }

  public void methodWithListNullableStringHandlerAsyncResult(Handler<AsyncResult<List<String>>> handler) { 
    delegate.methodWithListNullableStringHandlerAsyncResult(handler);
  }

  public void methodWithListNullableStringHandlerAsyncResult() {
    methodWithListNullableStringHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<String>> rxMethodWithListNullableStringHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableStringHandlerAsyncResult($handler);
    });
  }

  public List<String> methodWithListNullableStringReturn() { 
    List<String> ret = delegate.methodWithListNullableStringReturn();
    return ret;
  }

  public void methodWithListNullableCharParam(List<Character> param) { 
    delegate.methodWithListNullableCharParam(param);
  }

  public void methodWithListNullableCharHandler(Handler<List<Character>> handler) { 
    delegate.methodWithListNullableCharHandler(handler);
  }

  public void methodWithListNullableCharHandlerAsyncResult(Handler<AsyncResult<List<Character>>> handler) { 
    delegate.methodWithListNullableCharHandlerAsyncResult(handler);
  }

  public void methodWithListNullableCharHandlerAsyncResult() {
    methodWithListNullableCharHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<Character>> rxMethodWithListNullableCharHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableCharHandlerAsyncResult($handler);
    });
  }

  public List<Character> methodWithListNullableCharReturn() { 
    List<Character> ret = delegate.methodWithListNullableCharReturn();
    return ret;
  }

  public void methodWithListNullableJsonObjectParam(List<JsonObject> param) { 
    delegate.methodWithListNullableJsonObjectParam(param);
  }

  public void methodWithListNullableJsonObjectHandler(Handler<List<JsonObject>> handler) { 
    delegate.methodWithListNullableJsonObjectHandler(handler);
  }

  public void methodWithListNullableJsonObjectHandlerAsyncResult(Handler<AsyncResult<List<JsonObject>>> handler) { 
    delegate.methodWithListNullableJsonObjectHandlerAsyncResult(handler);
  }

  public void methodWithListNullableJsonObjectHandlerAsyncResult() {
    methodWithListNullableJsonObjectHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<JsonObject>> rxMethodWithListNullableJsonObjectHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableJsonObjectHandlerAsyncResult($handler);
    });
  }

  public List<JsonObject> methodWithListNullableJsonObjectReturn() { 
    List<JsonObject> ret = delegate.methodWithListNullableJsonObjectReturn();
    return ret;
  }

  public void methodWithListNullableJsonArrayParam(List<JsonArray> param) { 
    delegate.methodWithListNullableJsonArrayParam(param);
  }

  public void methodWithListNullableJsonArrayHandler(Handler<List<JsonArray>> handler) { 
    delegate.methodWithListNullableJsonArrayHandler(handler);
  }

  public void methodWithListNullableJsonArrayHandlerAsyncResult(Handler<AsyncResult<List<JsonArray>>> handler) { 
    delegate.methodWithListNullableJsonArrayHandlerAsyncResult(handler);
  }

  public void methodWithListNullableJsonArrayHandlerAsyncResult() {
    methodWithListNullableJsonArrayHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<JsonArray>> rxMethodWithListNullableJsonArrayHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableJsonArrayHandlerAsyncResult($handler);
    });
  }

  public List<JsonArray> methodWithListNullableJsonArrayReturn() { 
    List<JsonArray> ret = delegate.methodWithListNullableJsonArrayReturn();
    return ret;
  }

  public void methodWithListNullableApiParam(List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithListNullableApiParam(param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toList()));
  }

  public void methodWithListNullableApiHandler(Handler<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithListNullableApiHandler(new Handler<List<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(List<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList()));
      }
    });
  }

  public void methodWithListNullableApiHandlerAsyncResult(Handler<AsyncResult<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithListNullableApiHandlerAsyncResult(new Handler<AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<List<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithListNullableApiHandlerAsyncResult() {
    methodWithListNullableApiHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithListNullableApiHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableApiHandlerAsyncResult($handler);
    });
  }

  public List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithListNullableApiReturn() { 
    List<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithListNullableApiReturn().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toList());
    return ret;
  }

  public void methodWithListNullableDataObjectParam(List<io.vertx.codegen.testmodel.TestDataObject> param) { 
    delegate.methodWithListNullableDataObjectParam(param);
  }

  public void methodWithListNullableDataObjectHandler(Handler<List<io.vertx.codegen.testmodel.TestDataObject>> handler) { 
    delegate.methodWithListNullableDataObjectHandler(handler);
  }

  public void methodWithListNullableDataObjectHandlerAsyncResult(Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestDataObject>>> handler) { 
    delegate.methodWithListNullableDataObjectHandlerAsyncResult(handler);
  }

  public void methodWithListNullableDataObjectHandlerAsyncResult() {
    methodWithListNullableDataObjectHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithListNullableDataObjectHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableDataObjectHandlerAsyncResult($handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestDataObject> methodWithListNullableDataObjectReturn() { 
    List<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithListNullableDataObjectReturn();
    return ret;
  }

  public void methodWithListNullableEnumParam(List<io.vertx.codegen.testmodel.TestEnum> param) { 
    delegate.methodWithListNullableEnumParam(param);
  }

  public void methodWithListNullableEnumHandler(Handler<List<io.vertx.codegen.testmodel.TestEnum>> handler) { 
    delegate.methodWithListNullableEnumHandler(handler);
  }

  public void methodWithListNullableEnumHandlerAsyncResult(Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestEnum>>> handler) { 
    delegate.methodWithListNullableEnumHandlerAsyncResult(handler);
  }

  public void methodWithListNullableEnumHandlerAsyncResult() {
    methodWithListNullableEnumHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithListNullableEnumHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableEnumHandlerAsyncResult($handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestEnum> methodWithListNullableEnumReturn() { 
    List<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithListNullableEnumReturn();
    return ret;
  }

  public void methodWithListNullableGenEnumParam(List<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    delegate.methodWithListNullableGenEnumParam(param);
  }

  public void methodWithListNullableGenEnumHandler(Handler<List<io.vertx.codegen.testmodel.TestGenEnum>> handler) { 
    delegate.methodWithListNullableGenEnumHandler(handler);
  }

  public void methodWithListNullableGenEnumHandlerAsyncResult(Handler<AsyncResult<List<io.vertx.codegen.testmodel.TestGenEnum>>> handler) { 
    delegate.methodWithListNullableGenEnumHandlerAsyncResult(handler);
  }

  public void methodWithListNullableGenEnumHandlerAsyncResult() {
    methodWithListNullableGenEnumHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<List<io.vertx.codegen.testmodel.TestGenEnum>> rxMethodWithListNullableGenEnumHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithListNullableGenEnumHandlerAsyncResult($handler);
    });
  }

  public List<io.vertx.codegen.testmodel.TestGenEnum> methodWithListNullableGenEnumReturn() { 
    List<io.vertx.codegen.testmodel.TestGenEnum> ret = delegate.methodWithListNullableGenEnumReturn();
    return ret;
  }

  public void methodWithSetNullableByteParam(Set<Byte> param) { 
    delegate.methodWithSetNullableByteParam(param);
  }

  public void methodWithSetNullableByteHandler(Handler<Set<Byte>> handler) { 
    delegate.methodWithSetNullableByteHandler(handler);
  }

  public void methodWithSetNullableByteHandlerAsyncResult(Handler<AsyncResult<Set<Byte>>> handler) { 
    delegate.methodWithSetNullableByteHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableByteHandlerAsyncResult() {
    methodWithSetNullableByteHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Byte>> rxMethodWithSetNullableByteHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableByteHandlerAsyncResult($handler);
    });
  }

  public Set<Byte> methodWithSetNullableByteReturn() { 
    Set<Byte> ret = delegate.methodWithSetNullableByteReturn();
    return ret;
  }

  public void methodWithSetNullableShortParam(Set<Short> param) { 
    delegate.methodWithSetNullableShortParam(param);
  }

  public void methodWithSetNullableShortHandler(Handler<Set<Short>> handler) { 
    delegate.methodWithSetNullableShortHandler(handler);
  }

  public void methodWithSetNullableShortHandlerAsyncResult(Handler<AsyncResult<Set<Short>>> handler) { 
    delegate.methodWithSetNullableShortHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableShortHandlerAsyncResult() {
    methodWithSetNullableShortHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Short>> rxMethodWithSetNullableShortHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableShortHandlerAsyncResult($handler);
    });
  }

  public Set<Short> methodWithSetNullableShortReturn() { 
    Set<Short> ret = delegate.methodWithSetNullableShortReturn();
    return ret;
  }

  public void methodWithSetNullableIntegerParam(Set<Integer> param) { 
    delegate.methodWithSetNullableIntegerParam(param);
  }

  public void methodWithSetNullableIntegerHandler(Handler<Set<Integer>> handler) { 
    delegate.methodWithSetNullableIntegerHandler(handler);
  }

  public void methodWithSetNullableIntegerHandlerAsyncResult(Handler<AsyncResult<Set<Integer>>> handler) { 
    delegate.methodWithSetNullableIntegerHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableIntegerHandlerAsyncResult() {
    methodWithSetNullableIntegerHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Integer>> rxMethodWithSetNullableIntegerHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableIntegerHandlerAsyncResult($handler);
    });
  }

  public Set<Integer> methodWithSetNullableIntegerReturn() { 
    Set<Integer> ret = delegate.methodWithSetNullableIntegerReturn();
    return ret;
  }

  public void methodWithSetNullableLongParam(Set<Long> param) { 
    delegate.methodWithSetNullableLongParam(param);
  }

  public void methodWithSetNullableLongHandler(Handler<Set<Long>> handler) { 
    delegate.methodWithSetNullableLongHandler(handler);
  }

  public void methodWithSetNullableLongHandlerAsyncResult(Handler<AsyncResult<Set<Long>>> handler) { 
    delegate.methodWithSetNullableLongHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableLongHandlerAsyncResult() {
    methodWithSetNullableLongHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Long>> rxMethodWithSetNullableLongHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableLongHandlerAsyncResult($handler);
    });
  }

  public Set<Long> methodWithSetNullableLongReturn() { 
    Set<Long> ret = delegate.methodWithSetNullableLongReturn();
    return ret;
  }

  public void methodWithSetNullableBooleanParam(Set<Boolean> param) { 
    delegate.methodWithSetNullableBooleanParam(param);
  }

  public void methodWithSetNullableBooleanHandler(Handler<Set<Boolean>> handler) { 
    delegate.methodWithSetNullableBooleanHandler(handler);
  }

  public void methodWithSetNullableBooleanHandlerAsyncResult(Handler<AsyncResult<Set<Boolean>>> handler) { 
    delegate.methodWithSetNullableBooleanHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableBooleanHandlerAsyncResult() {
    methodWithSetNullableBooleanHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Boolean>> rxMethodWithSetNullableBooleanHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableBooleanHandlerAsyncResult($handler);
    });
  }

  public Set<Boolean> methodWithSetNullableBooleanReturn() { 
    Set<Boolean> ret = delegate.methodWithSetNullableBooleanReturn();
    return ret;
  }

  public void methodWithSetNullableFloatParam(Set<Float> param) { 
    delegate.methodWithSetNullableFloatParam(param);
  }

  public void methodWithSetNullableFloatHandler(Handler<Set<Float>> handler) { 
    delegate.methodWithSetNullableFloatHandler(handler);
  }

  public void methodWithSetNullableFloatHandlerAsyncResult(Handler<AsyncResult<Set<Float>>> handler) { 
    delegate.methodWithSetNullableFloatHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableFloatHandlerAsyncResult() {
    methodWithSetNullableFloatHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Float>> rxMethodWithSetNullableFloatHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableFloatHandlerAsyncResult($handler);
    });
  }

  public Set<Float> methodWithSetNullableFloatReturn() { 
    Set<Float> ret = delegate.methodWithSetNullableFloatReturn();
    return ret;
  }

  public void methodWithSetNullableDoubleParam(Set<Double> param) { 
    delegate.methodWithSetNullableDoubleParam(param);
  }

  public void methodWithSetNullableDoubleHandler(Handler<Set<Double>> handler) { 
    delegate.methodWithSetNullableDoubleHandler(handler);
  }

  public void methodWithSetNullableDoubleHandlerAsyncResult(Handler<AsyncResult<Set<Double>>> handler) { 
    delegate.methodWithSetNullableDoubleHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableDoubleHandlerAsyncResult() {
    methodWithSetNullableDoubleHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Double>> rxMethodWithSetNullableDoubleHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableDoubleHandlerAsyncResult($handler);
    });
  }

  public Set<Double> methodWithSetNullableDoubleReturn() { 
    Set<Double> ret = delegate.methodWithSetNullableDoubleReturn();
    return ret;
  }

  public void methodWithSetNullableStringParam(Set<String> param) { 
    delegate.methodWithSetNullableStringParam(param);
  }

  public void methodWithSetNullableStringHandler(Handler<Set<String>> handler) { 
    delegate.methodWithSetNullableStringHandler(handler);
  }

  public void methodWithSetNullableStringHandlerAsyncResult(Handler<AsyncResult<Set<String>>> handler) { 
    delegate.methodWithSetNullableStringHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableStringHandlerAsyncResult() {
    methodWithSetNullableStringHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<String>> rxMethodWithSetNullableStringHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableStringHandlerAsyncResult($handler);
    });
  }

  public Set<String> methodWithSetNullableStringReturn() { 
    Set<String> ret = delegate.methodWithSetNullableStringReturn();
    return ret;
  }

  public void methodWithSetNullableCharParam(Set<Character> param) { 
    delegate.methodWithSetNullableCharParam(param);
  }

  public void methodWithSetNullableCharHandler(Handler<Set<Character>> handler) { 
    delegate.methodWithSetNullableCharHandler(handler);
  }

  public void methodWithSetNullableCharHandlerAsyncResult(Handler<AsyncResult<Set<Character>>> handler) { 
    delegate.methodWithSetNullableCharHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableCharHandlerAsyncResult() {
    methodWithSetNullableCharHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<Character>> rxMethodWithSetNullableCharHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableCharHandlerAsyncResult($handler);
    });
  }

  public Set<Character> methodWithSetNullableCharReturn() { 
    Set<Character> ret = delegate.methodWithSetNullableCharReturn();
    return ret;
  }

  public void methodWithSetNullableJsonObjectParam(Set<JsonObject> param) { 
    delegate.methodWithSetNullableJsonObjectParam(param);
  }

  public void methodWithSetNullableJsonObjectHandler(Handler<Set<JsonObject>> handler) { 
    delegate.methodWithSetNullableJsonObjectHandler(handler);
  }

  public void methodWithSetNullableJsonObjectHandlerAsyncResult(Handler<AsyncResult<Set<JsonObject>>> handler) { 
    delegate.methodWithSetNullableJsonObjectHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableJsonObjectHandlerAsyncResult() {
    methodWithSetNullableJsonObjectHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<JsonObject>> rxMethodWithSetNullableJsonObjectHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableJsonObjectHandlerAsyncResult($handler);
    });
  }

  public Set<JsonObject> methodWithSetNullableJsonObjectReturn() { 
    Set<JsonObject> ret = delegate.methodWithSetNullableJsonObjectReturn();
    return ret;
  }

  public void methodWithSetNullableJsonArrayParam(Set<JsonArray> param) { 
    delegate.methodWithSetNullableJsonArrayParam(param);
  }

  public void methodWithSetNullableJsonArrayHandler(Handler<Set<JsonArray>> handler) { 
    delegate.methodWithSetNullableJsonArrayHandler(handler);
  }

  public void methodWithSetNullableJsonArrayHandlerAsyncResult(Handler<AsyncResult<Set<JsonArray>>> handler) { 
    delegate.methodWithSetNullableJsonArrayHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableJsonArrayHandlerAsyncResult() {
    methodWithSetNullableJsonArrayHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<JsonArray>> rxMethodWithSetNullableJsonArrayHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableJsonArrayHandlerAsyncResult($handler);
    });
  }

  public Set<JsonArray> methodWithSetNullableJsonArrayReturn() { 
    Set<JsonArray> ret = delegate.methodWithSetNullableJsonArrayReturn();
    return ret;
  }

  public void methodWithSetNullableApiParam(Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithSetNullableApiParam(param.stream().map(elt -> elt.getDelegate()).collect(Collectors.toSet()));
  }

  public void methodWithSetNullableApiHandler(Handler<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithSetNullableApiHandler(new Handler<Set<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(Set<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(event.stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet()));
      }
    });
  }

  public void methodWithSetNullableApiHandlerAsyncResult(Handler<AsyncResult<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithSetNullableApiHandlerAsyncResult(new Handler<AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<Set<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

  public void methodWithSetNullableApiHandlerAsyncResult() {
    methodWithSetNullableApiHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1>> rxMethodWithSetNullableApiHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableApiHandlerAsyncResult($handler);
    });
  }

  public Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> methodWithSetNullableApiReturn() { 
    Set<io.vertx.reactivex.codegen.testmodel.RefedInterface1> ret = delegate.methodWithSetNullableApiReturn().stream().map(elt -> io.vertx.reactivex.codegen.testmodel.RefedInterface1.newInstance((io.vertx.codegen.testmodel.RefedInterface1)elt)).collect(Collectors.toSet());
    return ret;
  }

  public void methodWithSetNullableDataObjectParam(Set<io.vertx.codegen.testmodel.TestDataObject> param) { 
    delegate.methodWithSetNullableDataObjectParam(param);
  }

  public void methodWithSetNullableDataObjectHandler(Handler<Set<io.vertx.codegen.testmodel.TestDataObject>> handler) { 
    delegate.methodWithSetNullableDataObjectHandler(handler);
  }

  public void methodWithSetNullableDataObjectHandlerAsyncResult(Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestDataObject>>> handler) { 
    delegate.methodWithSetNullableDataObjectHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableDataObjectHandlerAsyncResult() {
    methodWithSetNullableDataObjectHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.codegen.testmodel.TestDataObject>> rxMethodWithSetNullableDataObjectHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableDataObjectHandlerAsyncResult($handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestDataObject> methodWithSetNullableDataObjectReturn() { 
    Set<io.vertx.codegen.testmodel.TestDataObject> ret = delegate.methodWithSetNullableDataObjectReturn();
    return ret;
  }

  public void methodWithSetNullableEnumParam(Set<io.vertx.codegen.testmodel.TestEnum> param) { 
    delegate.methodWithSetNullableEnumParam(param);
  }

  public void methodWithSetNullableEnumHandler(Handler<Set<io.vertx.codegen.testmodel.TestEnum>> handler) { 
    delegate.methodWithSetNullableEnumHandler(handler);
  }

  public void methodWithSetNullableEnumHandlerAsyncResult(Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestEnum>>> handler) { 
    delegate.methodWithSetNullableEnumHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableEnumHandlerAsyncResult() {
    methodWithSetNullableEnumHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.codegen.testmodel.TestEnum>> rxMethodWithSetNullableEnumHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableEnumHandlerAsyncResult($handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestEnum> methodWithSetNullableEnumReturn() { 
    Set<io.vertx.codegen.testmodel.TestEnum> ret = delegate.methodWithSetNullableEnumReturn();
    return ret;
  }

  public void methodWithSetNullableGenEnumParam(Set<io.vertx.codegen.testmodel.TestGenEnum> param) { 
    delegate.methodWithSetNullableGenEnumParam(param);
  }

  public void methodWithSetNullableGenEnumHandler(Handler<Set<io.vertx.codegen.testmodel.TestGenEnum>> handler) { 
    delegate.methodWithSetNullableGenEnumHandler(handler);
  }

  public void methodWithSetNullableGenEnumHandlerAsyncResult(Handler<AsyncResult<Set<io.vertx.codegen.testmodel.TestGenEnum>>> handler) { 
    delegate.methodWithSetNullableGenEnumHandlerAsyncResult(handler);
  }

  public void methodWithSetNullableGenEnumHandlerAsyncResult() {
    methodWithSetNullableGenEnumHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<Set<io.vertx.codegen.testmodel.TestGenEnum>> rxMethodWithSetNullableGenEnumHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithSetNullableGenEnumHandlerAsyncResult($handler);
    });
  }

  public Set<io.vertx.codegen.testmodel.TestGenEnum> methodWithSetNullableGenEnumReturn() { 
    Set<io.vertx.codegen.testmodel.TestGenEnum> ret = delegate.methodWithSetNullableGenEnumReturn();
    return ret;
  }

  public void methodWithMapNullableByteParam(java.util.Map<String, Byte> param) { 
    delegate.methodWithMapNullableByteParam(param);
  }

  public void methodWithMapNullableByteHandler(Handler<java.util.Map<String, Byte>> handler) { 
    delegate.methodWithMapNullableByteHandler(handler);
  }

  public void methodWithMapNullableByteHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Byte>>> handler) { 
    delegate.methodWithMapNullableByteHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableByteHandlerAsyncResult() {
    methodWithMapNullableByteHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Byte>> rxMethodWithMapNullableByteHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableByteHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Byte> methodWithMapNullableByteReturn() { 
    java.util.Map<String, Byte> ret = delegate.methodWithMapNullableByteReturn();
    return ret;
  }

  public void methodWithMapNullableShortParam(java.util.Map<String, Short> param) { 
    delegate.methodWithMapNullableShortParam(param);
  }

  public void methodWithMapNullableShortHandler(Handler<java.util.Map<String, Short>> handler) { 
    delegate.methodWithMapNullableShortHandler(handler);
  }

  public void methodWithMapNullableShortHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Short>>> handler) { 
    delegate.methodWithMapNullableShortHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableShortHandlerAsyncResult() {
    methodWithMapNullableShortHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Short>> rxMethodWithMapNullableShortHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableShortHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Short> methodWithMapNullableShortReturn() { 
    java.util.Map<String, Short> ret = delegate.methodWithMapNullableShortReturn();
    return ret;
  }

  public void methodWithMapNullableIntegerParam(java.util.Map<String, Integer> param) { 
    delegate.methodWithMapNullableIntegerParam(param);
  }

  public void methodWithMapNullableIntegerHandler(Handler<java.util.Map<String, Integer>> handler) { 
    delegate.methodWithMapNullableIntegerHandler(handler);
  }

  public void methodWithMapNullableIntegerHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Integer>>> handler) { 
    delegate.methodWithMapNullableIntegerHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableIntegerHandlerAsyncResult() {
    methodWithMapNullableIntegerHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Integer>> rxMethodWithMapNullableIntegerHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableIntegerHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Integer> methodWithMapNullableIntegerReturn() { 
    java.util.Map<String, Integer> ret = delegate.methodWithMapNullableIntegerReturn();
    return ret;
  }

  public void methodWithMapNullableLongParam(java.util.Map<String, Long> param) { 
    delegate.methodWithMapNullableLongParam(param);
  }

  public void methodWithMapNullableLongHandler(Handler<java.util.Map<String, Long>> handler) { 
    delegate.methodWithMapNullableLongHandler(handler);
  }

  public void methodWithMapNullableLongHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Long>>> handler) { 
    delegate.methodWithMapNullableLongHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableLongHandlerAsyncResult() {
    methodWithMapNullableLongHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Long>> rxMethodWithMapNullableLongHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableLongHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Long> methodWithMapNullableLongReturn() { 
    java.util.Map<String, Long> ret = delegate.methodWithMapNullableLongReturn();
    return ret;
  }

  public void methodWithMapNullableBooleanParam(java.util.Map<String, Boolean> param) { 
    delegate.methodWithMapNullableBooleanParam(param);
  }

  public void methodWithMapNullableBooleanHandler(Handler<java.util.Map<String, Boolean>> handler) { 
    delegate.methodWithMapNullableBooleanHandler(handler);
  }

  public void methodWithMapNullableBooleanHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Boolean>>> handler) { 
    delegate.methodWithMapNullableBooleanHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableBooleanHandlerAsyncResult() {
    methodWithMapNullableBooleanHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Boolean>> rxMethodWithMapNullableBooleanHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableBooleanHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Boolean> methodWithMapNullableBooleanReturn() { 
    java.util.Map<String, Boolean> ret = delegate.methodWithMapNullableBooleanReturn();
    return ret;
  }

  public void methodWithMapNullableFloatParam(java.util.Map<String, Float> param) { 
    delegate.methodWithMapNullableFloatParam(param);
  }

  public void methodWithMapNullableFloatHandler(Handler<java.util.Map<String, Float>> handler) { 
    delegate.methodWithMapNullableFloatHandler(handler);
  }

  public void methodWithMapNullableFloatHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Float>>> handler) { 
    delegate.methodWithMapNullableFloatHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableFloatHandlerAsyncResult() {
    methodWithMapNullableFloatHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Float>> rxMethodWithMapNullableFloatHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableFloatHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Float> methodWithMapNullableFloatReturn() { 
    java.util.Map<String, Float> ret = delegate.methodWithMapNullableFloatReturn();
    return ret;
  }

  public void methodWithMapNullableDoubleParam(java.util.Map<String, Double> param) { 
    delegate.methodWithMapNullableDoubleParam(param);
  }

  public void methodWithMapNullableDoubleHandler(Handler<java.util.Map<String, Double>> handler) { 
    delegate.methodWithMapNullableDoubleHandler(handler);
  }

  public void methodWithMapNullableDoubleHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Double>>> handler) { 
    delegate.methodWithMapNullableDoubleHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableDoubleHandlerAsyncResult() {
    methodWithMapNullableDoubleHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Double>> rxMethodWithMapNullableDoubleHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableDoubleHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Double> methodWithMapNullableDoubleReturn() { 
    java.util.Map<String, Double> ret = delegate.methodWithMapNullableDoubleReturn();
    return ret;
  }

  public void methodWithMapNullableStringParam(java.util.Map<String, String> param) { 
    delegate.methodWithMapNullableStringParam(param);
  }

  public void methodWithMapNullableStringHandler(Handler<java.util.Map<String, String>> handler) { 
    delegate.methodWithMapNullableStringHandler(handler);
  }

  public void methodWithMapNullableStringHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, String>>> handler) { 
    delegate.methodWithMapNullableStringHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableStringHandlerAsyncResult() {
    methodWithMapNullableStringHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, String>> rxMethodWithMapNullableStringHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableStringHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, String> methodWithMapNullableStringReturn() { 
    java.util.Map<String, String> ret = delegate.methodWithMapNullableStringReturn();
    return ret;
  }

  public void methodWithMapNullableCharParam(java.util.Map<String, Character> param) { 
    delegate.methodWithMapNullableCharParam(param);
  }

  public void methodWithMapNullableCharHandler(Handler<java.util.Map<String, Character>> handler) { 
    delegate.methodWithMapNullableCharHandler(handler);
  }

  public void methodWithMapNullableCharHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, Character>>> handler) { 
    delegate.methodWithMapNullableCharHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableCharHandlerAsyncResult() {
    methodWithMapNullableCharHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, Character>> rxMethodWithMapNullableCharHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableCharHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, Character> methodWithMapNullableCharReturn() { 
    java.util.Map<String, Character> ret = delegate.methodWithMapNullableCharReturn();
    return ret;
  }

  public void methodWithMapNullableJsonObjectParam(java.util.Map<String, JsonObject> param) { 
    delegate.methodWithMapNullableJsonObjectParam(param);
  }

  public void methodWithMapNullableJsonObjectHandler(Handler<java.util.Map<String, JsonObject>> handler) { 
    delegate.methodWithMapNullableJsonObjectHandler(handler);
  }

  public void methodWithMapNullableJsonObjectHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, JsonObject>>> handler) { 
    delegate.methodWithMapNullableJsonObjectHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableJsonObjectHandlerAsyncResult() {
    methodWithMapNullableJsonObjectHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, JsonObject>> rxMethodWithMapNullableJsonObjectHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableJsonObjectHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, JsonObject> methodWithMapNullableJsonObjectReturn() { 
    java.util.Map<String, JsonObject> ret = delegate.methodWithMapNullableJsonObjectReturn();
    return ret;
  }

  public void methodWithMapNullableJsonArrayParam(java.util.Map<String, JsonArray> param) { 
    delegate.methodWithMapNullableJsonArrayParam(param);
  }

  public void methodWithMapNullableJsonArrayHandler(Handler<java.util.Map<String, JsonArray>> handler) { 
    delegate.methodWithMapNullableJsonArrayHandler(handler);
  }

  public void methodWithMapNullableJsonArrayHandlerAsyncResult(Handler<AsyncResult<java.util.Map<String, JsonArray>>> handler) { 
    delegate.methodWithMapNullableJsonArrayHandlerAsyncResult(handler);
  }

  public void methodWithMapNullableJsonArrayHandlerAsyncResult() {
    methodWithMapNullableJsonArrayHandlerAsyncResult(ar -> { });
  }

  public io.reactivex.Single<java.util.Map<String, JsonArray>> rxMethodWithMapNullableJsonArrayHandlerAsyncResult() { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithMapNullableJsonArrayHandlerAsyncResult($handler);
    });
  }

  public java.util.Map<String, JsonArray> methodWithMapNullableJsonArrayReturn() { 
    java.util.Map<String, JsonArray> ret = delegate.methodWithMapNullableJsonArrayReturn();
    return ret;
  }

  public void methodWithMapNullableApiParam(java.util.Map<String, io.vertx.reactivex.codegen.testmodel.RefedInterface1> param) { 
    delegate.methodWithMapNullableApiParam(param.entrySet().stream().collect(Collectors.toMap(e -> e.getKey(), e -> e.getValue().getDelegate())));
  }

  public void methodWithNullableHandler(boolean expectNull, Handler<String> handler) { 
    delegate.methodWithNullableHandler(expectNull, handler);
  }

  public void methodWithNullableHandlerAsyncResult(boolean expectNull, Handler<AsyncResult<String>> handler) { 
    delegate.methodWithNullableHandlerAsyncResult(expectNull, handler);
  }

  public void methodWithNullableHandlerAsyncResult(boolean expectNull) {
    methodWithNullableHandlerAsyncResult(expectNull, ar -> { });
  }

  public io.reactivex.Single<String> rxMethodWithNullableHandlerAsyncResult(boolean expectNull) { 
    return AsyncResultSingle.toSingle($handler -> {
      methodWithNullableHandlerAsyncResult(expectNull, $handler);
    });
  }

  public static NullableTCK newInstance(io.vertx.codegen.testmodel.NullableTCK arg) {
    return arg != null ? new NullableTCK(arg) : null;
  }

}
